// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// BoolMatrix.hh --- header file that defines class BoolMatrix
// $Id: BoolMatrix.hh,v 4.0.1.1 1996/07/08 06:15:57 rt Exp $


#ifndef ___BOOLMATRIX_HH
#define ___BOOLMATRIX_HH

// ͤιΤۤ
class BoolMatrixY: public RefTable< bool > {
  public:
    void set_value( bool x = false ) {
        for ( register int i = 0; i < number(); i++ )
            operator[]( i ) = x;
    }

    bool and_all() {
        bool ret_val = true;
        for ( register int i = 0; i < number(); i++ ) {
            ret_val = ret_val && operator[]( i );
        }
        return ret_val;
    }

  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (BoolMatrixY)\n";
    }
};

// ͤ
class BoolTable: public BoolMatrixY {

  private:

    void error26_name() const {
        cerr << "Error: subscript out of range (BoolTable)\n";
    }
};        


// ͤι
class BoolMatrix: public RefTable< BoolMatrixY > {

  private:

    void error26_name() const {
        cerr << "Error: subscript out of range (BoolMatrixX)\n";
    }

  public:

    void set_value( bool x = false ) {	// Ǥ x ˤ
        for ( register int i = 0; i < number(); i++ )
            operator[]( i ).set_value( x );
    }

    void square_setnum( int i ) {	// 
        setnum( i );
        for ( register int j = 0; j < i; j++ ) setnum( i );
    }
};


#endif /* ! ___BOOLMATRIX_HH */
