// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// GlobalSched.cc --- class GlobalSched functions
// $Id: GlobalSched.cc,v 4.0.1.1 1996/07/08 06:15:57 rt Exp $

#include "GlobalSched.hh"

void
GlobalSched::numbering
() {
    for ( register int i = 0; i < number(); i++ ) {
        operator[]( i ).set_id( i );
    }
}

int operator>>
( istream& str, GlobalSched& x ) {
    if ( getinttime ( str, x.tm_cycle ) == EOF ) return -1;
    cerr << ": " << x.tm_cycle << "\n";
    int ntr;
    if ( getint ( str, ntr ) == EOF ) return -1;
    cerr << "ֿ: " << ntr << "\n";
    x.setnum ( ntr );
    x.numbering();
    for ( register int i = 0; i < x.number(); i++ ) {
        x[ i ].set_cycle( x.tm_cycle );
        cerr << " " << i << ":\n";
        if ( str >> x[ i ] ) return -1;
    }
    if ( ( comment_out( str ) != EOF ) ) return 1;
    return 0;
}

void
GlobalSched::transfer_station_timetable
( PathSearch& stnd ) {
    for ( register int k = 0; k < number(); k++ ) {
        operator[]( k ).transfer_station_timetable( stnd );
    }
}

// ãǽľãǽODθ
//  pe ˤơľãǽ OD ˤ -1 ãǽ OD ˤ 1 Ϳ
void
GlobalSched::reachability_search
( PathExist& pe ) {
    int i, j, k;

    //  pe 򥼥ꥻå
    for ( i = 0; i < pe.number(); i++ ) {
        for ( j = 0; j < pe[ i ].number(); j++ ) {
            pe[ i ][ j ] = 0;
        }
    }

    // ľãǽOD -1 ޡ
    for ( i = 0; i < number(); i++ ) {
        for ( j = 0; j < ( *this )[ i ].number(); j++ ) {
            for ( k = 0; k <= j; k++ ) {
                int id_stn_dep = ( *this )[ i ][ k ].id_stn_dep;
                int id_stn_arr = ( *this )[ i ][ j ].id_stn_arr;
                pe[ id_stn_dep ][ id_stn_arr ] = -1;
            }
        }
    }

    // ãǽODޡ
    cerr << "ãǽΥå: ";
    for ( i = 0; i < REACHABILITY_CHECK_CIRC; i++ ) {
        cerr << i + 1 << " ";
        if ( reachability_search_sub( pe ) ) {
            cerr << "λ\n";
            break;
        } else if ( i + 1 == REACHABILITY_CHECK_CIRC ) {
            cerr << "\nWarning: reachability_check not complete\n";
        }
    }
}


// ãǽODθ
//  pe ˤơãǽ OD  1 Ϳ
//  1 Ϳ줿 pe Ǥʤʤ鸡λ
bool
GlobalSched::reachability_search_sub
( PathExist& pe ) {
    int i, j, k;
    bool ret_val = true;
    for ( i = 0; i < pe.number(); i++ ) {
        for ( j = 0; j < pe[ i ].number(); j++ ) {
            if ( i == j
                 || ( ! pe[ i ][ j ] ) ) continue;
            for ( k = 0; k < pe.number(); k++ ) {
                if ( k == i || k == j ) continue;
                // ¦
                if ( pe[ k ][ i ] && ( ! pe[ k ][ j ] ) ) {
                    ret_val = false;
                    pe[ k ][ j ] = 1;
                }
                // ߼¦
                if ( pe[ j ][ k ] && ( ! pe[ i ][ k ] ) ) {
                    ret_val = false;
                    pe[ i ][ k ] = 1;
                }
            }
        }
    }
    return ret_val;
}
