// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// LineData.cc --- class LineData functions
// $Id: LineData.cc,v 4.0.1.2 1996/07/08 08:38:56 rt Exp $

#include "LineData.hh"


// ǡɤ߹
int
operator>>
( istream& str, LineData& x ) {

    // ¸ٽϥǡե̾
    if ( getcommand ( str, x.fnconges ) == EOF ) return -1;

    // ؿ (nsect)
    // ֿ nsect - 1 Ǥ뤳Ȥաڻ
    // ľϩΥߥ졼ԤݤˤϤդΤ
    int nsect;
    if ( getint ( str, nsect ) == EOF ) return -1;
    if ( nsect < 1 ) {
        cerr << "Error: Number of stations should be "
             << "more than one in Line Data\n";
        exit(33);
    }
    x.setnum ( nsect - 1 );

    // ֹɤ߹
    int iprev;		// ֹֻ
    int ipost;		// ֹֽ
    if ( getint ( str, iprev ) == EOF ) return -1;
    for ( register int i = 0; i < x.number(); i++ ) {
        if ( getint ( str, ipost ) == EOF ) return -1;
        x[ i ].set_stations( iprev, ipost );
        iprev = ipost;
    }
    return 0;
}


// ǡν񤭽Ф
ostream&
operator<<
( ostream& str, LineData& x ) {

    // ¸ٽϥǡե̾
    str << "\n*** ϩֹ " << x.id_line << "::\n";
    str << "    - ¸٥սϥե̾: " << x.fnconges << "\n";
    str << "    - ؽ: " << x[ 0 ].starting_station();
    for ( register int i = 0; i < x.number(); i++ ) {
        str << " " << x[ i ].ending_station();
    }
    str << "\n";
    return str;
}


// ؤɤΥˤ뤫
// ȯ: 0 : number()
// ڻ!! ֹȤϰۤʤֹŪˤ֤Ȥˤʤ
// #### ľϩΥߥ졼ŬѤդɬ
int
LineData::determine_section_cell
( int id_stn ) {
    register int i;
    for ( i = 0; i < number(); i++ ) {
        if ( id_stn == operator[]( i ).starting_station() ) {
            return i;
        }
    }
    if ( id_stn == last().ending_station() ) {
        return number();
    }
    return -1;
}

// ǡˤ SectionData ν
int
LineData::prepare_section_data_cells
( int id_tr, int id_ssr, LineNumberContainerCell lnc )
{
    // ȯؤΰַ
    int id_cell_st = determine_section_cell( lnc.id_stn_st );
    if ( id_cell_st < 0 ) return 1;

    // ؤΰַ
    int id_cell_end = determine_section_cell( lnc.id_stn_end );
    if ( id_cell_end < 0 ) return 1;

    // SectionData Τʤˤ
    // TrainRunningOnSectionDataCell ֥Ȥκ
    static TrainRunningOnSectionDataCell tmptrosdc;
    tmptrosdc.id_tr = id_tr;
    tmptrosdc.id_ssr = id_ssr;
    
    // ڻġĥֹŬڤľ
    cerr << "" << id_tr << ": ϩ" << id_line
         << ", SSR " << id_ssr << ": ";
    register int i;
    if ( id_cell_st > id_cell_end ) {
        for ( i = id_cell_end; i < id_cell_st; i++ ) {
            cerr << operator[]( i ).starting_station() << "<-";
            operator[]( i ) += tmptrosdc;
        }
        cerr << operator[]( id_cell_st - 1 ).ending_station() << "\n";
        return 0;
    } 
    else if ( id_cell_st < id_cell_end ) {
        for ( i = id_cell_st; i < id_cell_end; i++ ) {
            cerr << operator[]( i ).starting_station() << "->";
            operator[]( i ) += tmptrosdc;
        }
        cerr << operator[]( id_cell_end - 1 ).ending_station() << "\n";
        return 0;
    }
    else {
        cerr << "\n";
        return 1;	// ƱäѤ
    }
}



// ٲξ GlobalSched 饹Ф
void
LineData::extract_congestion_data
( GlobalSched& dia ) {
    for ( register int i = 0; i < number(); i++ ) {
        operator[]( i ).extract_congestion_data( dia );
    }
}


// ¸٤η׻
void
LineData::calculate_congestion() {
    for ( register int i = 0; i < number(); i++ ) {
        operator[]( i ).calculate_congestion();
    }
}


// 
void
LineData::congesout( ostream& oout )
{
    oout << "ϩ " << id_line << " μ¸: (եǡ "
         << fnconges << " ե)\n";
    for ( register int i = 0; i < number(); i++ ) {
      oout << setw(2) << setfill(' ') << operator[]( i ).starting_station()
	   << "->" << setw(2) << operator[]( i ).ending_station()
	   << ": " /* << setw(8) << setfill(' ') */ << setprecision(4)
	   << operator[]( i ).congestion() << "()\n";
    }
    oout << "\n";
}


// հ ... gnuplot
void
LineData::graphout_gnuplot()
{
    // ޥɥե
    ofstream ogr( fnconges.c_str() );
    string dfncon = fnconges + ".Xdata";
    ogr << "plot \"" << dfncon << "\" w lines\n";
    ogr.close();

    // ǡե
    ogr.open( dfncon.c_str() );
    graphout_datapair( ogr );
    ogr.close();
}


// հ ... xgraph
void
LineData::graphout_xgraph() {
    ofstream ogr( fnconges.c_str() );
    graphout_datapair( ogr );
    ogr.close();
}


// հ ... gnuplot / xgraph ̥롼
void
LineData::graphout_datapair
( ostream& ogr )
{
    bool sw_first = true;
    int i;
    for ( i = 0; i < number(); i++ ) {
        if ( sw_first ) {
            ogr << i << " " << 0 << "\n";
            sw_first = false;
        }
        ogr << i << " "
            << operator[]( i ).congestion() << "\n";
        ogr << i + 1 << " "
            << operator[]( i ).congestion() << "\n";
    }
    ogr << i << " " << 0 << "\n";
}
