// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// LineData.hh --- header file that defines class LineData
// $Id: LineData.hh,v 4.0.1.2 1996/07/08 08:38:56 rt Exp $

#include <string>
#include "SectionData.hh"
#include "PathCell.hh"

#ifndef ___LINEDATA_HH
#define ___LINEDATA_HH


// ϩǡ
class LineData: public RefTable< SectionData > {

  protected:
    int id_line;	// ϩֹ
    string fnconges;	// ¸Ψեǡե̾

  public:
    LineData(): RefTable< SectionData >(), fnconges()
        {id_line = 0;}

    LineData( const LineData& x ): RefTable< SectionData >( x ) 
        {membercopy( x );}

    LineData& operator=( const LineData& x ) {
        if ( &x == this ) return *this;
        RefTable< SectionData >::operator=( x );
        membercopy( x ); return *this;
    }

    void set_line_number( int i ) {id_line = i;}
    int line_number() {return id_line;}

    // ǡˤ SectionData ν
    int prepare_section_data_cells
    ( int, int, LineNumberContainerCell );

    // ¸٤뤿ΥǡФӼºݤη׻
    void extract_congestion_data( GlobalSched& );
    void calculate_congestion();

    // 
    void congesout( ostream& );
    void graphout_gnuplot();
    void graphout_xgraph();


    // ؤϤɤΥ?  : (int) ¸ߤʤ֤ͤ
    int determine_section_cell( int );

    friend int operator>> ( istream&, LineData& );
    friend ostream& operator<< ( ostream&, LineData& );

  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (LineData)\n";
    }

    void membercopy( const LineData& x ) {
        id_line = x.id_line;	fnconges = x.fnconges;
    }

    // Gnuplot / xgraph ̽ϥ롼
    void graphout_datapair( ostream& );
};


#endif /* ! ___LINEDATA_HH */
