// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// LineMap.cc --- class LineMap functions
// $Id: LineMap.cc,v 4.0.1.2 1996/07/08 08:38:56 rt Exp $

#include "LineMap.hh"
#include "BoolMatrix.hh"

// ǡɤ߹
int
operator>>
( istream& str, LineMap& x ) {

    // ϩ
    int itmp;
    if ( getint ( str, itmp ) == EOF ) return -1;
    x.setnum( itmp );
    x.set_line_number();

    // ϩΥǡɤ߹
    for ( register int i = 0; i < x.number(); i++ ) {
        itmp = ( str >> x[ i ] );
        if ( itmp ) return itmp;
    }
    if ( ( comment_out( str ) != EOF ) ) return 1;
    return 0;
}


// ǡν񤭽Ф
ostream&
operator<<
( ostream& str, LineMap& x ) {

    // ϩ
    str << "\nϩ: " << x.number() << "\n";
    for ( register int i = 0; i < x.number(); i++ ) {
        str << x[ i ];
    }
    return str;
}


// إǡ˴ؤå
void
LineMap::check_station_range
( int nstn, const string& fnlmp, const string& fnstn ) {
    // ؤ LineMap ֥ȤΤɤϿƤ뤫
    // ݤĴ٤뤿 bool Υå
    static BoolTable station_in_line;
    station_in_line.setnum( nstn );	// nstn: ؿ
    station_in_line.set_value();	// false ˥å

    register int i, j;

    // LineData ܴطĴ
    for ( i = 0; i < number(); i++ ) {
        for ( j = 0; j < operator[]( i ).number() - 1; j++ ) {
            if ( ! operator[]( i )[ j ].is_next_to_starting_station_of
                 ( operator[]( i )[ j + 1 ] ) )
                error77( fnlmp, fnstn );
        }
    }

    // LineMap ˸ֹå
    for ( i = 0; i < number(); i++ ) {
        for ( j = 0; j < operator[]( i ).number(); j++ ) {
            static SectionData tmpsd;
            tmpsd = operator[]( i )[ j ];
            if ( tmpsd.starting_station() >= nstn
                 || tmpsd.ending_station() >= nstn ) {
                error77( fnlmp, fnstn );
            }
            station_in_line[ tmpsd.starting_station() ] = true;
            station_in_line[ tmpsd.ending_station() ] = true;
        }
    }
    if ( ! station_in_line.and_all() ) {
        cerr << "Warning: some station(s) are not listed in"
             << " line data file \"" << fnlmp << "\".\n";
        cerr << "Warning: check the file if necessary.\n";
    }
}


// ǡ˴ؤå
void
LineMap::prepare_section_data_cells
( GlobalSched& dia, const string& fnlmp, const string& fndia )
{
    static LineNumberContainer lnc;
    // GlobalSched 饹 TrainSched 饹
    // Υ֥1Ĥ1֤б
    for ( int id_tr = 0; id_tr < dia.number(); id_tr++ )
    {
        // dia[ id_tr ].[ (int) ]  TrainSchedCell ֥
        for ( int id_ssr = 0; id_ssr < dia[ id_tr ].number(); id_ssr++ )
        {
            // ϩֹ楻
            lnc = dia[ id_tr ][ id_ssr ].lnc;
            for ( register int k = 0; k < lnc.number(); k++ )
            {
                // lnc[ k ]: LineNumberContainerCell ֥
                // number(): ϩб
                if ( lnc[ k ].id_line < 0 ||
                     lnc[ k ].id_line >= number() ) {
                    error77( fnlmp, fndia );
                }
                // operator[]( id_line ):
                // ϩб LineData ֥
                if ( operator[]( lnc[ k ].id_line )
                     .prepare_section_data_cells
                     ( id_tr, id_ssr, lnc[ k ] ) ) {
                    error77( fnlmp, fndia );
                }
            }
        }
    }
}


// ٲξ GlobalSched 饹Ф
void
LineMap::extract_congestion_data
( GlobalSched& dia ) {
    for ( register int i = 0; i < number(); i++ ) {
        operator[]( i ).extract_congestion_data( dia );
    }
}


// ¸٤η׻
void
LineMap::calculate_congestion() {
    for ( register int i = 0; i < number(); i++ ) {
        operator[]( i ).calculate_congestion();
    }
}


// 
void
LineMap::congesout( ostream& oout ) {
    for ( register int i = 0; i < number(); i++ ) {
        operator[]( i ).congesout( oout );
    }
}


// հ ... gnuplot
void
LineMap::graphout_gnuplot() {
    for ( register int i = 0; i < number(); i++ ) {
        operator[]( i ).graphout_gnuplot();
    }
}


// հ ... xgraph
void
LineMap::graphout_xgraph() {
    for ( register int i = 0; i < number(); i++ ) {
        operator[]( i ).graphout_xgraph();
    }
}
