// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// LineMap.hh --- header file that defines class LineMap
// $Id: LineMap.hh,v 4.0.1.2 1996/07/08 08:38:56 rt Exp $

#include "LineData.hh"
#include "GlobalSched.hh"

#ifndef ___LINEMAP_HH
#define ___LINEMAP_HH


// ϩǡ
class LineMap: public RefTable< LineData > {
    // ɲåǡʤ

  public:
    // 󥹥ȥ饯¿ʬʤ

    void set_line_number() {
        for ( register int i = 0; i < number(); i++ ) {
            operator[]( i ).set_line_number( i );
        }
    }

    void check_station_range( int, const string&, const string& );
    void prepare_section_data_cells
    ( GlobalSched&, const string&, const string& );

    // ¸٤뤿ΥǡФӼºݤη׻
    void extract_congestion_data( GlobalSched& );
    void calculate_congestion();

    // 
    void congesout( ostream& );
    void graphout_gnuplot();
    void graphout_xgraph();

    friend int operator>> ( istream&, LineMap& );
    friend ostream& operator<< ( ostream&, LineMap& );

  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (LineMap)\n";
    }
    void error77
    ( const string& fnlmp, const string& fnother ) const {
        cerr << "Error: files \"" << fnlmp << "\" and \"" << fnother
             << "\" do not conform to each other.\n";
        exit( 77 );
    }
};


#endif /* ! ___LINEMAP_HH */
