// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// PathCell.cc --- class PathCell functions
// $Id: PathCell.cc,v 4.0.1.2 1996/07/08 08:38:56 rt Exp $

#include "PathCell.hh"

// ٤ȯ֤1Τˤ
PathCell&
PathCell::operator++
() {
    if ( tm_cycle == 0 ) {
        cerr << "Error: Cycle still not informed to this PathCell object\n";
        exit( 1 );
    }
    tm_dep += tm_cycle;
    tm_arr += tm_cycle;
    cyc_tr++;
    return *this;
}

// ʤߤȯ֤1Τˤ
PathCell&
PathCell::operator--
() {
    if ( tm_cycle == 0 ) {
        cerr << "Error: Cycle still not informed to this PathCell object\n";
        exit( 1 );
    }
    tm_dep -= tm_cycle;
    tm_arr -= tm_cycle;
    cyc_tr--;
    return *this;
}

void
PathCell::adjust_cyc_tr
( int cyc_x ) {
    register int i;
    for ( i = cyc_tr; i < cyc_x; i++ ) {
        ( *this )++;
    }
    for ( i = cyc_tr; i > cyc_x; i-- ) {
        ( *this )--;
    }
}

void
PathCell::adjust_cyc_tr
( PathCell& x ) {
    adjust_cyc_tr( x.cyc_tr );
}


int
PathCell::cyc_for_cyclize_arrival
() {
    PathCell x = ( *this );
    while ( x.tm_arr >= tm_cycle ) {
        x--;
    }
    while ( x.tm_arr < 0 ) {
        x++;
    }
    return cyc_tr - x.cyc_tr;
}

int
PathCell::cyc_for_cyclize_departure
() {
    PathCell x = ( *this );
    while ( x.tm_dep >= tm_cycle ) {
        x--;
    }
    while ( x.tm_dep < 0 ) {
        x++;
    }
    return cyc_tr - x.cyc_tr;
}


// ֹ椬ۤʤ false (0) ֹ椬ƱǤְ֤
// 㤦 2 ֹ桦ְ֤פ뤬٤ܿ㤦
//  -2 򡢤٤Ʊξ -1 ֤
int operator==
( const PathCell& x, const PathCell& y ) {

    // ֹ椬ۤʤ
    if ( x.id_tr != y.id_tr )
        return 0;

    // ְ֤㤦
    if ( x.id_stn_dep != y.id_stn_dep
         || x.id_stn_arr != y.id_stn_arr )
        return 2;

    // ٤ܿ㤦
    if ( x.cyc_tr != y.cyc_tr )
        return -2;

    // פƤȻפ
    return -1;
}


// ֹ椬ۤʤäƤ true ֤
bool operator!=
( const PathCell& x, const PathCell& y ) {
    if ( x.id_tr != y.id_tr ) return true;
    else return false;
}


// ֹ椬Ʊˡ٤κ֤
int operator-
( const PathCell& x, const PathCell& y ) {
    if ( x != y ) {
        cerr << "Error: PathCell subtraction: train numbers differ\n";
        exit ( 9 );
    }
    return x.cyc_tr - y.cyc_tr;
}


void
PathCell::fit_in_cycle_arrival
() {
    while ( tm_arr >= tm_cycle ) {
        ( *this )--;
    }
    while ( tm_arr < 0 ) {
        ( *this )++;
    }
}

void
PathCell::fit_in_cycle_departure
() {
    while ( tm_dep >= tm_cycle ) {
        ( *this )--;
    }
    while ( tm_dep < 0 ) {
        ( *this )++;
    }
}


// ٤ܿ򸽺ߤͤǤͤ
PathCell&
PathCell::operator+=
( int x ) {
    int cyc_new = cyc_tr + x;
    adjust_cyc_tr( cyc_new );
    return *this;
}


// ٤ܿ򸽺ߤͤǤͤ
PathCell&
PathCell::operator-=
( int x ) {
    int cyc_new = cyc_tr - x;
    adjust_cyc_tr( cyc_new );
    return *this;
}


ostream& operator<<
( ostream& str, PathCell& x ) {
  str << setw(3) << setfill(' ') << x.id_stn_dep << setw(0)
      << "(" << setw(5) << setfill(' ') << x.tm_dep << setw(0)
      << ")" << setw(3) << setfill(' ') << x.id_tr << setw(0)
      << "[" << setw(3) << setfill(' ') << x.cyc_tr << setw(0)
      << "]->(" << setw(5) << setfill(' ') << x.tm_arr << setw(0) << ")";
  return str;
}
