// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// PathCell.hh --- header file that defines class PathCell
// $Id: PathCell.hh,v 4.0.1.2 1996/07/08 08:38:56 rt Exp $

#include <stdio.h>
// #include <std.h>
// #include <string.h>
#include <ctype.h>
#include <stdarg.h>

#include <string>
#include <iostream.h>
#include <iomanip.h>

#include "ReadData.hh"
#include "RefTable.hh"

#ifndef ___PATHCELL_HH
#define ___PATHCELL_HH


struct LineNumberContainerCell {
    int id_line;	// ϩֹ
    int id_stn_st;	// ¦ֹ
    int id_stn_end;	// ¦ֹ
};
    

class LineNumberContainer:
public RefTable< LineNumberContainerCell > {
  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (LineNumberContainer)\n";
    }
};

struct PathCell {

    int tm_cycle;	//  (ȥ꡼ˤϽ񤫤ʤ)
    int tm_trf;		/* ؤǤξ费׻ (ȥ꡼ˤϽ񤫤ʤ)
                           -1: 费ʤ -2: (default) */
    int tm_wait;	/* ؤǤξ费Ԥ (ȥ꡼ˤϽ񤫤ʤ)
                           费׻֤Ȥκʬ -1: 费ʤ */
    int id_sched;	// Υֹ (ȥ꡼ˤϽ񤫤ʤ)
    int id_tr;		// ֹ (ȥ꡼ˤϽ񤫤ʤ)
    int id_stn_dep;	// ȯֹ
    int id_stn_arr;	// ֹ
    LineNumberContainer lnc;	// ϩֹ楳ƥ
    int tm_dep;		// ȯػ
    int tm_arr;		// 
    int cyc_tr;		// Ρּ٤ܿ

    int num_passen;	// Ϳ: ˤäựϰۤʤ

    PathCell(): lnc() {
        tm_cycle = id_stn_dep = tm_dep = id_stn_arr =
            tm_arr = cyc_tr = num_passen = 0;
        id_sched = id_tr = 0;
        tm_trf = tm_wait = -2;
    }

    PathCell( const PathCell& x ): lnc( x.lnc ) {
        membercopy( x );
    }

    PathCell& operator=( const PathCell& x ) {
        if ( &x == this ) return *this;
        lnc = x.lnc;
        membercopy( x ); return *this;
    }

    void membercopy( const PathCell& x ) {
        tm_cycle = x.tm_cycle;		tm_trf = x.tm_trf;
        tm_wait = x.tm_wait;		id_sched = x.id_sched;
        id_tr = x.id_tr;		id_stn_dep = x.id_stn_dep;
        id_stn_arr = x.id_stn_arr;	tm_dep = x.tm_dep;
        tm_arr = x.tm_arr;		cyc_tr = x.cyc_tr;
        num_passen = x.num_passen;
    }

    // ʤߡ٤ȯ
    PathCell& operator++();		// ֤1Τˤ
    PathCell& operator++( int x ) {return operator++();}
    PathCell& operator--();		// ֤1Τˤ
    PathCell& operator--( int x ) {return operator--();}
    void fit_in_cycle_arrival();
    void fit_in_cycle_departure();

    // ʤߡ٤ͤ˹碌
    void adjust_cyc_tr( int );
    void adjust_cyc_tr( PathCell& );

    // ʤߡ٤򸽺ߤͤǤͤ
    PathCell& operator+=( int );
    PathCell& operator-=( int );

    // Ŭڤ˿ʤor٤餻ȯor֤0tm_cycleȤ
    // פ٤Ρֿʤ̡
    // Τ褦򤹤ȡͤػɽ˵ҤͤƱȤʤ
    int cyc_for_cyclize_arrival();
    int cyc_for_cyclize_departure();

    // Ӵط ---------------------------------------

    // ֹ椬ۤʤ false ֤
    // ֹ椬ƱǤְ֤㤦 2 ֤
    // ֹ椬ƱǶְ֤פ -2 ֤
    // ٤Ʊξ -1 ֤
    friend int operator==( const PathCell&, const PathCell& );

    // ֹ椬ۤʤäƤ true ֤
    friend bool operator!=( const PathCell&, const PathCell& );
    
    // ֹƱˡּ٤ܿפκ֤
    friend int operator-( const PathCell&, const PathCell& );

    friend ostream& operator<< ( ostream&, PathCell& );
};
    

#endif /* ! ___PATHCELL_HH */
