// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// PathMap.cc --- class PathMap functions
// $Id: PathMap.cc,v 4.0.1.2 1996/07/08 08:38:56 rt Exp $

#include "PathMap.hh"


// PathCell ˴ؤϢμ¸
// ֹ桦֤Ʊʤǧ
int
PathMap::operator()
( const PathCell& x ) {

    for ( register int i = 0; i < number(); i++ ) {
        PathCell xp = operator[]( i );
        if ( ( xp == x ) < 0 ) {	// PathCell::operator== ؿ
            return i;			// 򻲾Ȥ뤳
        }
    }
    cerr << "Error: no PathCell like this found in this PathMap object\n";
    exit( 26 );
    return 0;
}
    

//  x  operator[]( operator()( x ) ) Ȥμ٤ܿκ
int
PathMap::cyc_difference
( const PathCell& x ) {
    return x - ( *this )[ ( *this )( x ) ];
}
    

// ѥסġĽλϰʲ2ܤʳ return 0
// (1) Ʊ֤ǡƱޤϤ٤֤˾äƤ
//   硢ΥѥΤƤ return -1
// (2) ֤ã餳Υѥ tmp_pathtbl ˲ä return 1
// ΥѥκǸǤ뤳Ȥ
// ʤ֤ν۴ıžͤȤäȾ郎ǽ
int
PathMap::ck_forward_search_ended
( int id_jst ) const
{
    PathCell pcl = lastelement();

    // (1)θ
    // ѥ pcl ľΥѥƱ֤ʤʲΥåϤʤ
    bool sw_notrf = true;
    for ( register int i = number() - 2; i >= 0; i-- ) {
        PathCell pcx = element( i );

        // ǽξ费򸫤Ĥ sw_notrf  false ˤ
        if ( sw_notrf && ( pcx != pcl ) ) {
            sw_notrf = false;
        }

        // ǽξ费򸫤ĤޤǶ
        if ( sw_notrf ) {
            continue;
        }

        if ( ( pcx == pcl ) != 0 && pcl - pcx > 0 ) {
            // (1)ˤ꽪
            return -1;
        }
    }

    // (2)θ
    if ( pcl.id_stn_arr == id_jst ) {
        return 1;
    }

    // ɤʤΤ
    return 0;
}
    

// ѥסġĽλϰʲ2ܤʳ return 0
// (1) Ʊ֤ǡƱޤϤᤤ֤˾äƤ
//   硢ΥѥΤƤ return -1
// (2) ֤ã餳Υѥ tmp_pathtbl ˲ä return 1
// ΥѥκǸǤ뤳Ȥ
// ʤ֤ν۴ıžͤȤäȾ郎ǽ
int
PathMap::ck_backward_search_ended
( int id_jst ) const
{
    PathCell pcl = this->element( 0 );

    // (1)θ
    // ѥ pcl ľΥѥƱ֤ʤʲΥåϤʤ
    bool sw_notrf = true;
    for ( register int i = 1; i < number(); i++ ) {
        PathCell pcx = element( i );

        // ǽξ费򸫤Ĥ sw_notrf  false ˤ
        if ( sw_notrf && ( pcx != pcl ) ) {
            sw_notrf = false;
        }

        // ǽξ费򸫤ĤޤǶ
        if ( sw_notrf ) {
            continue;
        }

        if ( ( pcx == pcl ) != 0 && pcl - pcx < 0 ) {
            // (1)ˤ꽪
            return -1;
        }
    }

    // (2)θ
    if ( pcl.id_stn_dep == id_jst ) {
        return 1;
    }

    // ɤʤΤ
    return 0;
}


// õˤƱƱȯ֤Фѥ󥽡ѥץ
// ̤ͥϼ̤:
// (1) ǽ郎ᤤ
// (2) ǽؤޤǤξ费ʤ
// (3) ǽؤޤǤξ费׻֤¤ʤ
// (4) ǽؤޤǤԤ֤¤ʤʡ
// ޤǸư㤤ʤлʤΤ 0 ֤
// ax  bx Τ̤ۤͥ⤤ 1 ֤
// bx  ax Τ̤ۤͥ⤤ -1 ֤
int sortpathmap_forward
( const void* ax, const void* bx ) {
    PathMap* a = ( PathMap* ) ax;
    PathMap* b = ( PathMap* ) bx;

    // 롼(1)Ŭ
    if ( a->last().tm_arr > b->last().tm_arr ) return 1;
    else if ( a->last().tm_arr < b->last().tm_arr ) return -1;

    // 롼(2)Ŭ
    if ( a->transfer_occasions() > b->transfer_occasions() )
        return 1;
    else if ( a->transfer_occasions() < b->transfer_occasions() )
        return -1;

    // 롼(3)Ŭ
    if ( a->transfer_time() > b->transfer_time() )
        return 1;
    else if ( a->transfer_time() < b->transfer_time() )
        return -1;

    // 롼(4)Ŭ
    if ( a->wait_time() > b->wait_time() )
        return 1;
    else if ( a->wait_time() < b->wait_time() )
        return -1;

    // ɤŬѤǤʤäΤǡ֤ޤ
    return 0;
}


// ˤѥ󥽡
void
PathTable::sort_for_forward_search
() {
    if ( num > 0 ) {
        qsort( data, num, sizeof( PathMap ), sortpathmap_forward );
    }
}


// õˤƱƱȯ֤Фѥ󥽡ѥץ
// ̤ͥϼ̤:
// (1) ؽȯ郎٤
// (2) ؤޤǤξ费ʤ
// (3) ؤޤǤξ费׻֤¤ʤ
// (4) ؤޤǤԤ֤¤ʤʡ
// ޤǸư㤤ʤлʤΤ 0 ֤
// ax  bx Τ̤ۤͥ⤤ 1 ֤
// bx  ax Τ̤ۤͥ⤤ -1 ֤
int sortpathmap_backward
( const void* ax, const void* bx ) {
    PathMap* a = ( PathMap* ) ax;
    PathMap* b = ( PathMap* ) bx;

    // 롼(1)ŬѡġĤ羮طա
    if ( ( *a )[ 0 ].tm_dep < ( *b )[ 0 ].tm_dep ) return 1;
    else if ( ( *a )[ 0 ].tm_dep > ( *b )[ 0 ].tm_dep ) return -1;

    // 롼(2)Ŭ
    if ( a->transfer_occasions() > b->transfer_occasions() )
        return 1;
    else if ( a->transfer_occasions() < b->transfer_occasions() )
        return -1;

    // 롼(3)Ŭ
    if ( a->transfer_time() > b->transfer_time() )
        return 1;
    else if ( a->transfer_time() < b->transfer_time() )
        return -1;

    // 롼(4)Ŭ
    if ( a->wait_time() > b->wait_time() )
        return 1;
    else if ( a->wait_time() < b->wait_time() )
        return -1;

    // ɤŬѤǤʤäΤǡ֤ޤ
    return 0;
}


// ˤѥ󥽡
void
PathTable::sort_for_backward_search
() {
    if ( num > 0 ) {
        qsort( data, num, sizeof( PathMap ), sortpathmap_backward );
    }
}


// ѥޥåץեν
ostream& operator<<
( ostream& str, PathMap& x ) {

    if ( x.number() == 0 ) {
        str << "*** ޥå ***\n";
        return str;
    }
    bool sw_forw = false;
    bool sw_back = false;

    // Ĵʰˡѹ
    if ( x[ 0 ].tm_trf == ISFORWARDSEARCH ) sw_forw = true;
    if ( x.last().tm_trf == ISBACKWARDSEARCH ) sw_back = true;

    int i_dp = 0;
    int i_x = 0;
    while ( i_dp < x.number() ) {
        if ( i_x == 3 ) {
            i_x = 0;
            str << setw(2) << setfill(' ') << x[ i_dp - 1 ].id_stn_arr
		<< setw(0) << "\n   ";
        }
        str << setw(2) << setfill(' ') << x[ i_dp ].id_stn_dep
	    << setw(0) << "";
        if ( sw_forw && i_dp != 0 ) {
            str << setw(3) << setfill(' ')
		<< x[ i_dp ].tm_trf << setw(0) << "/";
        }
        str << setw(4) << setfill(' ') << x[ i_dp ].tm_dep << setw(0) << ">"
            << setw(2) << setfill(' ') << x[ i_dp ].id_tr << setw(0) << ">";
        // 费ʤȤϤȤФ
        if ( sw_forw ) {
            while ( i_dp < x.number() - 1
                    && ( x[ i_dp + 1 ].tm_trf < 0 ) ) {
                i_dp++;
            }
        }
        if ( sw_back ) {
            while ( i_dp < x.number() - 1
                    && ( x[ i_dp ].tm_trf < 0 ) ) {
                i_dp++;
            }
        }
        str << setw(4) << setfill(' ') << x[ i_dp ].tm_arr << setw(0);
        if ( sw_back && i_dp != x.number() - 1 ) {
            str << "/" << setw(3) << setfill(' ') << x[ i_dp ].tm_trf << setw(0);
        }
        str << ":";
        i_dp++;
        i_x++;
    }
    str << setw(2) << setfill(' ') << x.last().id_stn_arr << setw(0) << "\n";
    str << "     费" << x.transfer_occasions() << " "
        << x.transfer_time() << " Ԥ" << x.wait_time()
        << "";
    if ( x.trains_in_path() > 0 ) {
        str << "/ " << x.headway() << " (Ʊѥ"
            << x.trains_in_path() << ")";
    }
    str << "\n";
    return str;
}


// ɾ̤η׻ Ԥ֤η׻
void
PathMap::forward_calculate_wait_time
() {
    tm_wait = 0;

    // 费ȯƤΤͭǤ뤳Ȥ
    for ( register int i = 0; i < number() - 1; i++ ) {
        if ( ( *this )[ i + 1 ].tm_trf >= 0 ) {
            int tmc = ( *this )[ i + 1 ].tm_dep;
            tmc -= ( *this )[ i ].tm_arr;
            tmc -= ( *this )[ i + 1 ].tm_trf;
            tm_wait += tmc;
        }
    }
}


// ɾ̤η׻ 费Ӿ费׻֤η׻
void
PathMap::forward_calculate_transfer
() {
    tm_trf = 0;
    num_trf = 0;
    for ( register int i = 1; i < number(); i++ ) {
        if ( ( *this )[ i ].tm_trf >= 0 ) {
            num_trf++;
            tm_trf += ( *this )[ i ].tm_trf;
        }
    }
}


// ɾ̤η׻ Ԥ֤η׻
void
PathMap::backward_calculate_wait_time
() {
    tm_wait = 0;

    // 费ȯƤΤͭǤ뤳Ȥ
    for ( register int i = number() - 1; i > 0; i-- ) {
        if ( ( *this )[ i - 1 ].tm_trf >= 0 ) {
            int tmc = ( *this )[ i ].tm_dep;
            tmc -= ( *this )[ i - 1 ].tm_arr;
            tmc -= ( *this )[ i - 1 ].tm_trf;
            tm_wait += tmc;
        }
    }
}


// ɾ̤η׻ 费Ӿ费׻֤η׻
void
PathMap::backward_calculate_transfer
() {
    tm_trf = 0;
    num_trf = 0;
    for ( register int i = number() - 2; i >= 0; i-- ) {
        if ( ( *this )[ i ].tm_trf >= 0 ) {
            num_trf++;
            tm_trf += ( *this )[ i ].tm_trf;
        }
    }
}


ostream& operator<<
( ostream& str, PathTable& x ) {
    for ( register int j = 0; j < x.number(); j++ )
        str << x[ j ];
    return str;
}


// Ȥ줿ѥơ֥椫֤褤֤
PathTable&
PathTable::select_forward
() {
    // Ĥäѥ0Ĥޤ1Ĥʤ餽Τޤ޼ʬȤ֤
    if ( number() <= 1 ) return *this;

    // ȥץˤäơƱפǧޤǿʤ
    int iend = 1;
    register int i;
    for ( i = 0; i < number() - 1; i++ ) {
        if ( sortpathmap_forward
             ( ( const void* ) ( &( ( *this )[ i ] ) ),
               ( const void* ) ( &( ( *this )[ i + 1 ] ) ) )
             == 0 ) {
            iend++;
        } else break;
    }

    // Ƭ顢ƱȤ줿ʬǡ֤
    static PathTable ret_val;
    ret_val.renew();
    for ( i = 0; i < iend; i++ ) {
        ret_val += ( *this )[ i ];
    }

    return ret_val;
}


// Ȥ줿ѥơ֥椫֤褤֤
PathTable&
PathTable::select_backward
() {
    // Ĥäѥ0Ĥޤ1Ĥʤ餽Τޤ޼ʬȤ֤
    if ( number() <= 1 ) return *this;

    // ȥץˤäơƱפǧޤǿʤ
    int iend = 1;
    register int i;
    for ( i = 0; i < number() - 1; i++ ) {
        if ( sortpathmap_backward
             ( ( const void* ) ( &( ( *this )[ i ] ) ),
               ( const void* ) ( &( ( *this )[ i + 1 ] ) ) )
             == 0 ) {
            iend++;
        } else break;
    }

    // Ƭ顢ƱȤ줿ʬǡ֤
    static PathTable ret_val;
    ret_val.renew();
    for ( i = 0; i < iend; i++ ) {
        ret_val += ( *this )[ i ];
    }

    return ret_val;
}
