// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// PathMap.hh --- header file that defines class PathMap
// $Id: PathMap.hh,v 4.0.1.2 1996/07/08 08:38:56 rt Exp $

#include "PathCell.hh"
#include "RefTable.hh"

#ifndef ___PATHMAP_HH
#define ___PATHMAP_HH


// 򼨤å
// ѥơ֥κǽ顦ǸΥ tm_trf 
#ifndef ISFORWARDSEARCH
#define ISFORWARDSEARCH -5
#endif
#ifndef ISBACKWARDSEARCH
#define ISBACKWARDSEARCH -10
#endif

class PathMap: public RefTable< PathCell > {
    int id_path;	// Υѥֹ
    int tm_wait;	// Ԥ
    int num_trf;	// 费
    int tm_trf;		// 费׻
    int tm_headway;	// ΥѥȤλ
    int num_trn;	// ƱȯΥѥΨ׻˻ѡ

  public:
    PathMap(): RefTable< PathCell >()
        {id_path = tm_wait = num_trf = tm_trf
             = tm_headway = num_trn = 0;}

    PathMap( const PathMap& x ): RefTable< PathCell >( x ) 
        {membercopy( x );}

    PathMap& operator=( const PathMap& x ) {
        if ( &x == this ) return *this;
        RefTable< PathCell >::operator=( x );
        membercopy( x ); return *this;
    }

    void set_id( int i ) {id_path = i;}

    friend ostream& operator<< ( ostream&, PathMap& );

    int operator()( const PathCell& );	// Ϣμ¸
    int cyc_difference			// Ϳ줿Υ
    ( const PathCell& );		// ȤΡʼ٤Ρ˺

    // ѡɾ̤η׻ط
    void forward_calculate_wait_time();	 // Ԥ֤η׻
    void forward_calculate_transfer();	 // 费׻֤η׻

    // ѡɾ̤η׻ط
    void backward_calculate_wait_time(); // Ԥ֤η׻
    void backward_calculate_transfer();	 // 费׻֤η׻

    // ѥط
    int ck_forward_search_ended( int ) const;	/* ѥλ
                                                   פƤ뤫 check */
    int ck_backward_search_ended( int ) const;	/* ѥλ
                                                   פƤ뤫 check */
    int& wait_time() {return tm_wait;}
    int transfer_time() {return tm_trf;}
    int transfer_occasions() {return num_trf;}
    int headway() {return tm_headway;}
    void set_headway( int i ) {tm_headway = i;}
    int trains_in_path() {return num_trn;}
    void set_trains_in_path( int i ) {num_trn = i;}

  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (PathMap)\n";
    }

    void membercopy( const PathMap& x ) {
        id_path = x.id_path;	tm_wait = x.tm_wait;
        num_trf = x.num_trf;	tm_trf = x.tm_trf;
        num_trn = x.num_trn;	tm_headway = x.tm_headway;
    }

};


class PathTable: public RefTable< PathMap > {

  public:

    // ѥط
    virtual void sort_for_forward_search();
    virtual PathTable& select_forward();
    virtual void sort_for_backward_search();
    virtual PathTable& select_backward();

  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (PathTable)\n";
    }

  public:
    friend ostream& operator<<( ostream&, PathTable& );
};


// 嵭Υѥѥȥץ
int sortpathmap_forward( const void*,  const void* );
int sortpathmap_backward( const void*,  const void* );


class PathTblTbl: public RefTable< PathTable > {
  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (PathTblTbl)\n";
    }
};

class PathMatrix: public RefTable< PathTblTbl > {

  public:
    friend ostream& operator<< ( ostream&, PathMatrix& );

  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (PathMatrixX)\n";
    }
};


#endif /* ! ___PATHMAP_HH */
