// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// PathSearch.cc --- class PathSearch functions
// $Id: PathSearch.cc,v 4.0.1.1 1996/07/08 06:15:57 rt Exp $

#include "PathSearch.hh"

// Ϣμ¸ arrival ¦
PathSearchCell&
PathSearch::cell_arrival
( PathCell& x ) {
    return operator[]( x.id_stn_arr );
}


// Ϣμ¸ departure ¦
PathSearchCell&
PathSearch::cell_departure
( PathCell& x ) {
    return operator[]( x.id_stn_dep );
}


// PathCell ǡ PathSearchCell::arrival ɲ
PathSearch&
PathSearch::operator+=
( PathCell& x ) {
    cell_arrival( x ) += x;
    return *this;
}


// PathCell ǡ PathSearchCell::departure ɲ
PathSearch&
PathSearch::operator*=
( PathCell& x ) {
    cell_departure( x ) *= x;
    return *this;
}


// PathSearch 饹ξ费֥ơ֥Υåȥå
void
PathSearch::trf_set_trnum
( int trnum ) {
    for ( register int i = 0; i < number(); i++ ) {
        ( *this )[ i ].trf_set_trnum( trnum );
    }
}


// PathSearch 饹ξ费֥ơ֥ե뤫ɤ
void
PathSearch::rd_transfertime
( istream& str, string& fn ) {
    int ntt;
    if ( getint ( str, ntt ) == EOF ) {
        err_eof_noexit( fn ) << ": insufficient item(s)\n";
        exit( 1 );
    }
    for ( register int i = 0; i < ntt; i++ ) {
        int nst;
        if ( getint ( str, nst ) == EOF ) {
            err_eof_noexit( fn ) << ": insufficient item(s)\n";
            exit( 1 );
        }
        if ( this->out_of_range( nst ) ) {
            err_eof_noexit( fn ) << ": station number "
                                 << nst << " out of range\n";
            exit( 1 );
        }
        operator[]( nst ).rd_transfertime( str, fn );
        cerr << "at station #" << nst << ".\n";
    }
    if ( ( comment_out( str ) != EOF ) ) {
        err_eof_noexit( fn ) << ": too many item(s)\n";
        exit( 1 );
    }
}

// ػɽ򥽡Ȥƴ
void
PathSearch::make_station_timetable
() {
    for ( register int i = 0; i < number(); i++ ) {
        operator[]( i ).sort();
        operator[]( i ).headway_check();
        operator[]( i ).transferability_check();
    }
}


// ػɽΰ
void
PathSearch::print_station_timetable
( ostream& str ) {
//     bool sw_sep;
    PathSearch& stnd = ( *this );
    for ( register int i = 0; i < stnd.number(); i++ ) {
        str << i << "ؤλɽ:\n";
        stnd[ i ].print_station_timetable( str );
    }
}


// ѥʾ F1 бˤν
void
PathSearch::prepare_for_forward_search
() {
    // ̳Ǽѥޥȥꥯν
    path_forward.setnum( number() );
    register int i;
    for ( i = 0; i < number(); i++ ) {
        path_forward[ i ].setnum( number() );
    }
    path_candidate_forward.setnum( number() );
    for ( i = 0; i < number(); i++ ) {
        path_candidate_forward[ i ].setnum( number() );
        for ( int j = 0; j < number(); j++ ) {
            path_candidate_forward[ i ][ j ].renew();
        }
    }

    // λǥޥȥꥯν
    psd.setnum( number() );
    for ( i = 0; i < number(); i++ ) {
        psd[ i ].setnum( number() );
        for ( int j = 0; j < number(); j++ ) {
            psd[ i ][ j ] = false;
        }
    }
}


// ѥʾ F1 б
void
PathSearch::search_forward
( ostream& pout, ostream& plog ) {
    cerr << "\n***** õˤѥ";

    for ( register int i = 0; i < number(); i++ ) {
        cerr << "\n" << i << "->";

        // 
        for ( register int j = 0; j < number(); j++ ) {
            cerr << " " << j;
            if ( i != j ) {
                search_forward_ij( i, j, pout, plog );
            }
        }
    }

    cerr << "\n\n***** ѥλޤ\n";
}


// ѥΥ֥ץ
//  i -> j ʬˤĤƤϤδؿޤ
void
PathSearch::search_forward_ij
( int id_ist, int id_jst, ostream& plog ) {
    search_forward_ij( id_ist, id_jst, cerr, plog, false );
}


// ѥΥ֥ץ
//  i -> j ʬˤĤƤϤδؿޤ
void
PathSearch::search_forward_ij
( int id_ist, int id_jst, ostream& pout, ostream& plog,
  bool sw_pout )
{

    PathCell p_init;
    tmp_finalpath.renew();

    plog << "\n**** ѥõ " << id_ist << " -> "
         << id_jst << "\n";
            
    // PathSearchCell Υѥơ֥
    pathtbl_forw.setnum( ( *this )[ id_ist ].departures() );
    register int i;
    for ( i = 0; i < pathtbl_forw.number(); i++ ) {
        pathtbl_forw[ i ].renew();
    }

    // ѥʤФ
    if ( ! pe[ id_ist ][ id_jst ] ) {
        plog << "::: ѥʤ :::\n\n";
        goto SKIPTOEND;
    }

    // ˸ä֤ʤФ
    if ( psd[ id_ist ][ id_jst ] ) {
        plog << "::: Ѥ :::\n\n";
        goto SKIPTOEND;
    }

    // ѥ ( *this )[ id_ist ].departingtrain( X ) 
    for ( i = 0;
         i < ( *this )[ id_ist ].departures(); i++ ) {

        // ѥ
        // tm_trf ޡ뤿 ISFORWARDSEARCH 
        p_init = ( *this )[ id_ist ].departingtrain( i );
        p_init.tm_trf = ISFORWARDSEARCH;

        // ƥݥѥꥹȤˤ
        tmp_pathtbl.renew( PATHCANDIDATE + 1 );

        // ѥ
        search_forward_sub( p_init, id_jst );
        // äƤиλ

        // Ƽɾ̤η׻ä˥ƥ󥰤Τ
        for ( register int j = 0; j < tmp_pathtbl.number(); j++ ) {
            tmp_pathtbl[ j ].forward_calculate_wait_time();
            tmp_pathtbl[ j ].forward_calculate_transfer();
        }

        // ƥݥѥơ֥򥽡
        tmp_pathtbl.sort_for_forward_search();

        // ե˽񤭹
        plog << "--- ѥ: " << p_init << p_init.id_stn_arr << " ---\n";
        plog << tmp_pathtbl;
        plog << "\n";

        // ѥơ֥˳Ǽ
        pathtbl_forw[ ( *this )[ id_ist ].departure_id( p_init ) ]
            = tmp_pathtbl;
    }

    // ѥơ֥Ƭ֤褤ġפȤäƤ
    tmp_finalpath = select_from_forward_path_table( id_ist, id_jst );

    // ǽ tmp_finalpath Ǽˤߡλޡ
    path_forward[ id_ist ][ id_jst ] = tmp_finalpath;
    psd[ id_ist ][ id_jst ] = true;

  SKIPTOEND:

    // ե˰
    plog << "***** ˤѥ " << id_ist << " -> "
         << id_jst << "\n";
    for ( i = 0; i < path_forward[ id_ist ][ id_jst ].number();
                 i++ ) {
        plog << path_forward[ id_ist ][ id_jst ][ i ];
    }
    if ( sw_pout ) {
        pout << "***** ѥ " << id_ist
             << " -> " << id_jst << "\n";
        for ( i = 0; i < path_forward[ id_ist ][ id_jst ].number();
                     i++ ) {
            pout << path_forward[ id_ist ][ id_jst ][ i ];
        }
    }
}


// ODڥͭѤƥѥ
//  psd ˤơڥֻȤ׶֤ˤĤƥѥ
//  true Ϳ줿 psd Ǥʤʤ鸡λ
bool
PathSearch::search_forward_using_searched
( ostream& oplg ) {
    int i, j, k;
    bool ret_val = true;
    for ( i = 0; i < psd.number(); i++ ) {
        for ( j = 0; j < psd.number(); j++ ) {
            if ( i == j
                 || ( ! psd[ i ][ j ] ) ) continue;
            for ( k = i - 1; k >= 0; k-- ) {
                if ( k == i || k == j ) continue;
                // ¦
                if ( psd[ k ][ i ] && ( ! psd[ k ][ j ] ) ) {
                    ret_val = false;
                    search_forward_ij( k, j, oplg );
                }
            }
            for ( k = i + 1; k < psd.number(); k++ ) {
                if ( k == i || k == j ) continue;
                // ¦
                if ( psd[ k ][ i ] && ( ! psd[ k ][ j ] ) ) {
                    ret_val = false;
                    search_forward_ij( k, j, oplg );
                }
            }
        }
    }
    return ret_val;
}



// ѥ1ġıػɽ PathCell ȴФ
//  PathMap  xpm ˲ä롣
// λƤʤСxpm 򼡤Υѥ롼Ϥ
void
PathSearch::search_forward_sub
( PathCell st, int id_jst ) {

    // PathMap ǡ st 򤿤
    fspm.renew();
    fspm += st;

    // ѥλθ
    // λƤСtmp_pathtbl ؤԤ
    if ( sw_searched_forward( id_jst ) ) {
        fspm.pop();
        if ( fspm.number() > 0 ) {
            cerr << "Warning: strange... fspm should be 0\n";
        }
        return;
    }

    int depth = -1;

    // λƤʤΤǡ֥ĥ꡼θ
    search_forward_sub( id_jst, depth );

    fspm.pop();
    if ( fspm.number() > 0 ) {
        cerr << "Warning: strange... fspm should be 0\n";
    }

    return;
}


// ѥ2ġ PathMap νȤʤػɽ费ǽ
// PathCell ФƸ˲ä롣
// λƤʤС
// 夬ä PathMap 򤵤˼Υѥ롼Ϥ
void
PathSearch::search_forward_sub
( int id_jst, int depth ) {

    depth++;

    // ޤ depth ʤ᤮ȴʤΤǡ
    if ( depth >= PATHSEARCHLIMIT * number() ) {
        return;
    }

    // ѥޥåפ PathCell ǡ pcl 
    // 򤷤Ƥȡcell_arrival( pcl ) ɬפ PathSearchCell 
    // ƤӽФȤǤ褦ˤʤ
    PathCell pcl = fspm.last();

    // ǽΤ³֤٤ƤˤĤƥѥԤ
    for ( register int i = 0;
         i < cell_arrival( pcl ).forward_connections( pcl ); i++ ) {

        // 费ѥ
        // ּ٤ܿ׹碌⤳δؿǤäƤ
        PathCell xpc =
            cell_arrival( pcl ).forward_connection( pcl, i );

        // ѥ xpm ˥ԡ˥ǡ
        fspm += xpc;

        // Х롼ĤĤƤ
        if ( fspm.last().tm_dep -
             ( fspm.last().tm_trf < 0 ? 0 : fspm.last().tm_trf )
             < fspm[ fspm.number() - 2 ].tm_arr ) {
            cerr << "Internal Error (possibly bug):\n    Departure time";
            cerr << " earlier than is permitted by arrival time\n";
            for ( register int irror = 0;
                  irror < fspm.number(); irror++ ) {
                cerr << fspm[ irror ];
            }
            cerr << "\n";
            exit( 74 );
        }

        // ѥλθ
        if ( ! sw_searched_forward( id_jst ) ) {

            // λʤäΤǡ֥ĥ꡼򤵤˸
            search_forward_sub( id_jst, depth );
            // ֤äƤиλ
        }
        fspm.pop();	// 1û
    }
}


// ѥסġĽλϰʲιܡʳ return false
// (1) ߤκǽؤŪؤޤǤΥѥʤϤΥѥΤƤ
//   return true
// (2) Ʊ֤ǡƱޤϤ٤֤˾äƤ
//   硢ΥѥΤƤ return true
// (3) ֤ã餳Υѥ tmp_pathtbl ˲ä return true
// (4) 줿ѥ10İʾˤʤꡢΥѥκǰΤΤ
//   ˸ߤΥѥ뤳Ȥμ¤ʾΤƤ return true
// ΥѥκǸǤ뤳Ȥ
// ⤷αؤŪؤޤǤΥѥǤ˸Ƥʤ餽
bool
PathSearch::sw_searched_forward
( int id_jst ) {

    int i_ck = fspm.ck_forward_search_ended( id_jst );

    switch ( i_ck ) {
      case -1:
        // (2)ˤҤää
        return true;

      case 1:
        // (3)ĺѤ뤫ɤ
        add_fspm_in_forward_search();
        return true;

      case 0:
      default:	// ¾Ϲͤʤɤ
        // (1)򸡺
        if ( ! pe[ fspm.last().id_stn_arr ][ id_jst ] ) {
            return true;		// ΤƤ
        }

        // ѥԤƤ뤫򸡺
        if ( psd[ fspm.last().id_stn_arr ][ id_jst ] ) {
            connect_searched_path_forward( id_jst );
            return true;
        }

        // (4)򸡺
        fspm.forward_calculate_wait_time();
        fspm.forward_calculate_transfer();
        if ( tmp_pathtbl.number() >= PATHCANDIDATE &&
             sortpathmap_forward
             ( ( const void* ) ( &fspm ),
               ( const void* ) ( &( tmp_pathtbl.last() ) ) )
             > 0 ) {
            return true;		// 줬ΤƤ
        } else {
            return false;		// ϼΤƤʤ
        }
    }
}


void
PathSearch::add_fspm_in_forward_search
() {
    // ȤԤ PATHCANDIDATE ̰ʲڼΤ
    tmp_pathtbl += fspm;
    for ( register int j = 0; j < tmp_pathtbl.number(); j++ ) {
        tmp_pathtbl[ j ].forward_calculate_wait_time();
        tmp_pathtbl[ j ].forward_calculate_transfer();
    }
    tmp_pathtbl.sort_for_forward_search();
    if ( tmp_pathtbl.number() > PATHCANDIDATE ) {
        tmp_pathtbl.pop();	// ΤƤ
    }
}


void
PathSearch::connect_searched_path_forward
( int id_jst ) {
    PathCell pcl = fspm.last();
    int id_ixt = pcl.id_stn_arr;
    for ( int i = 0;
         i < ( *this )[ id_ixt ].forward_connections( pcl );
         i++ ) {
        PathCell pcx = ( *this )[ id_ixt ].forward_connection
            ( pcl, i );
        PathCell pcc;
        for ( int j = 0;
             j < path_candidate_forward[ id_ixt ][ id_jst ].number(); j++ ) {
            pcc = path_candidate_forward[ id_ixt ][ id_jst ][ j ][ 0 ];
            if ( pcc != pcx ) {
                continue;
            }
            int adpc = pcx - pcc;	// ٤κ
            fspm += pcx;
            register int k;
            for ( k = 1;
                 k < path_candidate_forward[ id_ixt ][ id_jst ][ j ].number();
                 k++ ) {
                pcc = path_candidate_forward[ id_ixt ][ id_jst ][ j ][ k ];
                pcc += adpc;	// ٤ pcx ˹碌
                fspm += pcc;
            }
            add_fspm_in_forward_search();
            for ( k = 0;
                 k < path_candidate_forward[ id_ixt ][ id_jst ][ j ].number();
                 k++ ) {
                fspm.pop();
            }
        }
    }
}
                     

// ѥơ֥椫бȯ뤴Ȥˡ֤褤֡פ
PathTable&
PathSearch::select_from_forward_path_table
( int id_ist, int id_jst ) {
    // ȤϤ˹ԤƤȲ

    static PathTblTbl tmpsel;	// βˤˤ餻ʤ
    static HeadwayTable hwyt;	// βˤˤ餻ʤ
    static PathTable ret_val;	// βˤˤ餻ʤ
    static PathSearched ckd;
    tmpsel.renew();
    hwyt.renew();
    ret_val.renew();

    // tmpsel, hwyt, ckd Υåȥå
    tmpsel.setnum( pathtbl_forw.number() );
    hwyt = ( *this )[ id_ist ].departure_headways();
    ckd.setnum( hwyt.number() );
    int i;
    for ( i = 0; i < ckd.number(); i++ ) {
        ckd[ i ].setnum( hwyt.number() );
        for ( int j = 0; j < ckd[ i ].number(); j++ ) {
            ckd[ i ][ j ] = false;
        }
    }

    //  PathTable ֥Ȥ˸Ǥ餤Ȥ
    // Τ
    // select_forward ؿ֤ϾʤȤƱΥѥ
    // ֤ȤˤΥɤ񤯡  ¤̤ʥѥ
    // 르ꥺƳʤ顢طʬ򤹤٤ƽľ
    // ɬפ㡧θʤɡ
    for ( i = 0; i < pathtbl_forw.number(); i++ ) {

        // ƽȯ뤴Ȥ򤵤줿Τ tmpsel ˳Ǽ
        tmpsel[ i ] = pathtbl_forw[ i ]
            .select_forward();
    }

    for ( i = 0; i < tmpsel.number(); i++ ) {
        path_candidate_forward[ id_ist ][ id_jst ] += tmpsel[ i ];
    }

    bool sw_end_pck;

    do {
        sw_end_pck = true;
        for ( i = 0; i < pathtbl_forw.number(); i++ ) {
            if ( hwyt[ i ] < 0 ) continue;
            bool sw_reject = false;

            // ѥΤ뼡ȯ֤ϲ֤ʡ
            int inext = i;
            bool sw_not_cycled = true;
            bool sw_nopath = false;
            do {
                inext++;
                if ( inext == pathtbl_forw.number() ) {
                    // ѥʤȤޤΤǤ
                    if ( sw_not_cycled ) {
                        sw_not_cycled = false;
                        inext = 0;
                    } else {
                        sw_nopath = true;
                        break;
                    }
                }
            } while ( tmpsel[ inext ].number() == 0
                      || hwyt[ inext ] < 0 );
            if ( sw_nopath ) {	// ѥʤ
                return ret_val;	// Υѥ֤
            }
            if ( tmpsel[ i ].number() == 0 ) {	// ѥҤȤĤʤ
                sw_reject = true;			// ꥸ

            } else if ( inext != i ) {	// ξʲԤ
                sw_end_pck = sw_end_pck && ckd[ i ][ inext ];
                if ( ckd[ i ][ inext ] ) continue;
                else ckd[ i ][ inext ] = true;
#ifdef OLDPATHSEARCH
                // ΥѥκǽФ ʣɤǤ褤
                PathCell nxcell = tmpsel[ inext ][ 0 ].last();

                // ߸ΥѥκǽФ
                PathCell currcell = tmpsel[ i ][ 0 ].last();

                // inext  i ˲󤵤줿ʤ nxcell 1٤餹
                if ( ! sw_not_cycled  ) nxcell++;

                // nxcell 郎߸ΥѥΤ
                // ᤫäꥸȤ
                if ( nxcell.tm_arr < currcell.tm_arr )
                    sw_reject = true;
#else
                // ΥѥФ ʣɤǤ褤
                PathMap nxmp = tmpsel[ inext ][ 0 ];

                // ߸ΥѥФ
                PathMap currmp = tmpsel[ i ][ 0 ];

                // inext  i ˲󤵤줿ʤ nxmp 1٤餹
                if ( ! sw_not_cycled ) {
                    for ( int xi = 0; xi < nxmp.number(); xi++ ) {
                        nxmp[ xi ]++;
                    }
                }

                // currmp  nxmp ͥ٤㤫äꥸȤ
                // nxmp ˤĤƤϡԤ֤˻֤ä
                currmp.forward_calculate_wait_time();
                currmp.forward_calculate_transfer();
                nxmp.forward_calculate_wait_time();
                nxmp.forward_calculate_transfer();
                nxmp.wait_time() += hwyt[ inext ];
                if ( sortpathmap_forward
                     ( ( const void* ) ( &currmp ),
                       ( const void* ) ( &nxmp ) )
                     > 0 ) {
                    sw_reject = true;
                }
#endif /* ! OLDPATHSEARCH */
            }

            // ꥸȤΤ: ֤򼡤֤­
            if ( sw_reject ) {
                hwyt[ inext ] += hwyt[ i ];
                hwyt[ i ] = -1;
            }
        }
    } while ( ! sw_end_pck );

    // 褤֤ͤκ
    static PathMap x;
    x.renew();
    for ( i = 0; i < pathtbl_forw.number(); i++ ) {
        for ( register int j = 0; j < tmpsel[ i ].number(); j++ ) {
            if ( hwyt[ i ] < 0 ) continue;
            x = tmpsel[ i ][ j ];
            x.set_headway( hwyt[ i ] );
            x.set_trains_in_path( tmpsel[ i ].number() );
            ret_val += x;
        }
    }

    return ret_val;
}


// ѥʾ F2 бˤν
void
PathSearch::prepare_for_backward_search
() {
    // ̳Ǽѥޥȥꥯν
    path_backward.setnum( number() );
    register int i;
    for ( i = 0; i < number(); i++ ) {
        path_backward[ i ].setnum( number() );
    }
    path_candidate_backward.setnum( number() );
    for ( i = 0; i < number(); i++ ) {
        path_candidate_backward[ i ].setnum( number() );
        for ( int j = 0; j < number(); j++ ) {
            path_candidate_backward[ i ][ j ].renew();
        }
    }

    // λǥޥȥꥯν
    psd.setnum( number() );
    for ( i = 0; i < number(); i++ ) {
        psd[ i ].setnum( number() );
        for ( int j = 0; j < number(); j++ ) {
            psd[ i ][ j ] = false;
        }
    }
}


// ѥʾ F2 б
void
PathSearch::search_backward
( ostream& pout, ostream& plog ) {
    cerr << "\n***** ѥ";

    for ( register int i = 0; i < number(); i++ ) {
        cerr << "\n" << i << "<-";

        // 
        for ( register int j = 0; j < number(); j++ ) {
            cerr << " " << j;
            if ( i != j ) {
                search_backward_ij( i, j, pout, plog );
            }
        }
    }

    cerr << "\n\n***** ѥλޤ\n";
}


// ѥΥ֥ץ
//  i -> j ʬˤĤƤϤδؿޤ
void
PathSearch::search_backward_ij
( int id_ist, int id_jst, ostream& plog ) {
    search_backward_ij( id_ist, id_jst, cerr, plog, false );
}


// ѥΥ֥ץ
//  i -> j ʬˤĤƤϤδؿޤ
void
PathSearch::search_backward_ij
( int id_ist, int id_jst, ostream& pout, ostream& plog,
  bool sw_pout )
{

    PathCell p_init;
    tmp_finalpath.renew();

    plog << "\n**** ѥõ " << id_ist << " <- "
         << id_jst << "\n";
            
    // PathSearchCell Υѥơ֥
    pathtbl_back.setnum( ( *this )[ id_ist ].arrivals() );
    register int i;
    for ( i = 0; i < pathtbl_back.number(); i++ ) {
        pathtbl_back[ i ].renew();
    }

    // ѥʤФ
    if ( ! pe[ id_jst ][ id_ist ] ) {
        plog << "::: ѥʤ :::\n\n";
        goto SKIPTOEND;
    }

    // ˸ä֤ʤФ
    if ( psd[ id_ist ][ id_jst ] ) {
        plog << "::: Ѥ :::\n\n";
        goto SKIPTOEND;
    }

    // ѥ ( *this )[ id_ist ].arrivingtrain( X ) 
    for ( i = 0;
         i < ( *this )[ id_ist ].arrivals(); i++ ) {

        // ѥ
        // tm_trf ϸޡ뤿 ISBACKWARDSEARCH 
        p_init = ( *this )[ id_ist ].arrivingtrain( i );
        p_init.tm_trf = ISBACKWARDSEARCH;

        // ƥݥѥꥹȤˤ
        tmp_pathtbl.renew();

        // ѥ
        search_backward_sub( p_init, id_jst );
        // äƤиλ

        // Ƽɾ̤η׻ä˥ƥ󥰤Τ
        for ( register int j = 0; j < tmp_pathtbl.number(); j++ ) {
            tmp_pathtbl[ j ].backward_calculate_wait_time();
            tmp_pathtbl[ j ].backward_calculate_transfer();
        }

        // ƥݥѥơ֥򥽡
        tmp_pathtbl.sort_for_backward_search();

        // ե˽񤭹
        plog << "--- ѥ: " << p_init << p_init.id_stn_arr << " ---\n";
        plog << tmp_pathtbl;
        plog << "\n";

        // ̤ѥơ֥˳Ǽ
        pathtbl_back[ ( *this )[ id_ist ].arrival_id( p_init ) ]
            = tmp_pathtbl;
    }

    // ѥơ֥Ƭ֤褤ġפȤäƤ
    tmp_finalpath = select_from_backward_path_table( id_ist, id_jst );

    // ǽ tmp_finalpath Ǽˤߡλޡ
    path_backward[ id_ist ][ id_jst ] = tmp_finalpath;
    psd[ id_ist ][ id_jst ] = true;

  SKIPTOEND:

    // ե˰
    plog << "***** ˤѥ " << id_ist << " <- "
         << id_jst << "\n";
    for ( i = 0; i < path_backward[ id_ist ][ id_jst ].number();
                 i++ ) {
        plog << path_backward[ id_ist ][ id_jst ][ i ];
    }
    if ( sw_pout ) {
        pout << "***** ѥ " << id_ist
             << " <- " << id_jst << "\n";
        for ( i = 0; i < path_backward[ id_ist ][ id_jst ].number();
                     i++ ) {
            pout << path_backward[ id_ist ][ id_jst ][ i ];
        }
    }
}


// ODڥͭѤƥѥ
//  psd ˤơڥֻȤ׶֤ˤĤƥѥ
//  true Ϳ줿 psd Ǥʤʤ鸡λ
bool
PathSearch::search_backward_using_searched
( ostream& oplg ) {
    int i, j, k;
    bool ret_val = true;
    for ( i = 0; i < psd.number(); i++ ) {
        for ( j = 0; j < psd.number(); j++ ) {
            if ( i == j
                 || ( ! psd[ i ][ j ] ) ) continue;
            for ( k = i - 1; k >= 0; k-- ) {
                if ( k == i || k == j ) continue;
                // ߼¦
                if ( psd[ k ][ i ] && ( ! psd[ k ][ j ] ) ) {
                    ret_val = false;
                    search_backward_ij( k, j, oplg );
                }
            }
            for ( k = i + 1; k < psd.number(); k++ ) {
                if ( k == i || k == j ) continue;
                // ߼¦
                if ( psd[ k ][ i ] && ( ! psd[ k ][ j ] ) ) {
                    ret_val = false;
                    search_backward_ij( k, j, oplg );
                }
            }
        }
    }
    return ret_val;
}


// ѥ1ġıػɽ PathCell ȴФ
//  PathMap  xpm Ƭ˲ä (*=)
// λƤʤСxpm 򼡤Υѥ롼Ϥ
void
PathSearch::search_backward_sub
( PathCell st, int id_jst ) {

    // PathMap ǡ st 򤿤
    fspm.renew();
    fspm *= st;

    // ѥλθ
    // λƤСtmp_pathtbl ؤԤ
    if ( sw_searched_backward( id_jst ) ) {
        fspm.shift();
        if ( fspm.number() > 0 ) {
            cerr << "Warning: strange... fspm should be 0\n";
        }
        return;
    }

    int depth = -1;

    // λƤʤΤǡ֥ĥ꡼θ
    search_backward_sub( id_jst, depth );

    fspm.shift();
    if ( fspm.number() > 0 ) {
        cerr << "Warning: strange... fspm should be 0\n";
    }

    return;
}


// ѥ2ġ PathMap λϤޤȤʤػɽ费ǽ
// PathCell ФƸƬ˲ä (*=)
// λƤʤС
// 夬ä PathMap 򤵤˼Υѥ롼Ϥ
void
PathSearch::search_backward_sub
( int id_jst, int depth ) {

    depth++;

    // ޤ depth ʤ᤮ȴʤΤǡ
    if ( depth >= PATHSEARCHLIMIT * number() ) {
        return;
    }

    // ѥޥåפƬ PathCell ǡ pcl 
    // 򤷤Ƥȡcell_departure( pcl ) ɬפ PathSearchCell 
    // ƤӽФȤǤ褦ˤʤ
    PathCell pcl = fspm[ 0 ];

    // ǽΤ³֤٤ƤˤĤƥѥԤ
    for ( register int i = 0;
         i < cell_departure( pcl ).backward_connections( pcl ); i++ ) {

        // 费ѥ
        // ּ٤ܿ׹碌⤳δؿǤäƤ
        PathCell xpc =
            cell_departure( pcl ).backward_connection( pcl, i );

        // ѥ xpm ˥ԡ˥ǡ
        fspm *= xpc;

        // Х롼ĤĤƤ
        if ( fspm[ 1 ].tm_dep -
             ( fspm[ 0 ].tm_trf < 0 ? 0 : fspm[ 0 ].tm_trf )
             < fspm[ 0 ].tm_arr ) {
            cerr << "Internal Error (possibly bug):\n    Arrival time";
            cerr << " earlier than is permitted by departure time\n";
            for ( register int irror = 0;
                 irror < fspm.number(); irror++ ) {
                cerr << fspm[ irror ];
            }
            cerr << "\n";
            exit( 74 );
        }

        // ѥλθ
        if ( ! sw_searched_backward( id_jst ) ) {

            // λʤäΤǡ֥ĥ꡼򤵤˸
            search_backward_sub( id_jst, depth );
            // ֤äƤиλ
        }
        fspm.shift();	// 1û
    }
}


// ѥλϰʲιܡʳ return false
// (1) ߤκǽؤȯؤޤǤΥѥʤϤΥѥΤƤ
//   return true
// (2) Ʊ֤ǡƱޤϤᤤ֤˾äƤ
//   硢ΥѥΤƤ return true
// (3) ֤ã餳Υѥ tmp_pathtbl ˲ä return true
// (4) 줿ѥ10İʾˤʤꡢΥѥκǰΤΤ
//   ˸ߤΥѥ뤳Ȥμ¤ʾΤƤ return true
// ΥѥκǽǤ뤳Ȥ
// ⤷αؤŪؤޤǤΥѥǤ˸Ƥʤ餽
bool
PathSearch::sw_searched_backward
( int id_jst ) {

    int i_ck = fspm.ck_backward_search_ended( id_jst );

    switch ( i_ck ) {
      case -1:
        // (2)ˤҤää
        return true;

      case 1:
        // (3)ĺѤ뤫ɤ
        add_fspm_in_backward_search();
        return true;

      case 0:
      default:	// ¾Ϲͤʤɤ
        // (1)򸡺
        if ( ! pe[ id_jst ][ fspm[ 0 ].id_stn_dep ] ) {
            return true;		// ΤƤ
        }

        // ѥԤƤ뤫򸡺
        if ( psd[ fspm[ 0 ].id_stn_dep ][ id_jst ] ) {
            connect_searched_path_backward( id_jst );
            return true;
        }

        // (4)򸡺
        fspm.backward_calculate_wait_time();
        fspm.backward_calculate_transfer();
        if ( tmp_pathtbl.number() >= PATHCANDIDATE &&
             sortpathmap_backward
             ( ( const void* ) ( &fspm ),
               ( const void* ) ( &( tmp_pathtbl.last() ) ) )
               > 0 ) {
            return true;		// 줬ΤƤ
        } else {
            return false;		// ϼΤƤʤ
        }
    }
}


void
PathSearch::add_fspm_in_backward_search
() {
    // ȤԤ PATHCANDIDATE ̰ʲڼΤ
    tmp_pathtbl += fspm;
    for ( register int j = 0; j < tmp_pathtbl.number(); j++ ) {
        tmp_pathtbl[ j ].backward_calculate_wait_time();
        tmp_pathtbl[ j ].backward_calculate_transfer();
    }
    tmp_pathtbl.sort_for_backward_search();
    if ( tmp_pathtbl.number() > PATHCANDIDATE ) {
        tmp_pathtbl.pop();	// ΤƤ
    }
}


void
PathSearch::connect_searched_path_backward
( int id_jst ) {
    PathCell pcl = fspm[ 0 ];
    int id_ixt = pcl.id_stn_dep;
    for ( int i = 0;
         i < ( *this )[ id_ixt ].backward_connections( pcl );
         i++ ) {
        PathCell pcx = ( *this )[ id_ixt ].backward_connection
            ( pcl, i );
        PathCell pcc;
        for ( int j = 0;
             j < path_candidate_backward[ id_ixt ][ id_jst ].number(); j++ ) {
            pcc = path_candidate_backward[ id_ixt ][ id_jst ][ j ].last();
            if ( pcc != pcx ) {
                continue;
            }
            int adpc = pcx - pcc;	// ٤κ
            fspm *= pcx;
            register int k;
            for ( k = path_candidate_backward[ id_ixt ][ id_jst ][ j ]
                     .number() - 2;
                 k >= 0; k-- ) {
                pcc = path_candidate_backward[ id_ixt ][ id_jst ][ j ][ k ];
                pcc += adpc;	// ٤ pcx ˹碌
                fspm *= pcc;
            }
            add_fspm_in_backward_search();
            for ( k = 0;
                 k < path_candidate_backward[ id_ixt ][ id_jst ][ j ].number();
                 k++ ) {
                fspm.shift();
            }
        }
    }
}


// ѥơ֥椫бȯ뤴Ȥˡ֤褤֡פ
PathTable&
PathSearch::select_from_backward_path_table
( int id_ist, int id_jst ) {
    // ȤϤ˹ԤƤȲ

    static PathTblTbl tmpsel;	// βˤˤ餻ʤ
    static HeadwayTable hwyt;	// βˤˤ餻ʤ
    static PathTable ret_val;	// βˤˤ餻ʤ
    static PathSearched ckd;
    tmpsel.renew();
    hwyt.renew();
    ret_val.renew();

    // tmpsel, hwyt, ckd Υåȥå
    tmpsel.setnum( pathtbl_back.number() );
    hwyt = ( *this )[ id_ist ].arrival_headways();
    ckd.setnum( hwyt.number() );
    register int i;
    for ( i = 0; i < ckd.number(); i++ ) {
        ckd[ i ].setnum( hwyt.number() );
        for ( int j = 0; j < ckd[ i ].number(); j++ ) {
            ckd[ i ][ j ] = false;
        }
    }

    //  PathTable ֥Ȥ˸Ǥ餤Ȥ
    // Τ
    // select_backward ؿ֤ϾʤȤƱΥѥ
    // ֤ȤˤΥɤ񤯡  ¤̤ʥѥ
    // 르ꥺƳʤ顢طʬ򤹤٤ƽľ
    // ɬפ㡧θʤɡ
    for ( i = 0; i < pathtbl_back.number(); i++ ) {

        // 奻뤴Ȥ򤵤줿Τ tmpsel ˳Ǽ
        tmpsel[ i ] = pathtbl_back[ i ]
            .select_backward();
    }

    for ( i = 0; i < tmpsel.number(); i++ ) {
        path_candidate_backward[ id_ist ][ id_jst ] += tmpsel[ i ];
    }

    bool sw_end_pck;

    do {
        sw_end_pck = true;
        for ( i = pathtbl_back.number() - 1; i >= 0; i-- ) {
            if ( hwyt[ i ] < 0 ) continue;
            bool sw_reject = false;

            // ѥΤ֤ϲ֤ʡ
            int inext = i;
            bool sw_not_cycled = true;
            bool sw_nopath = false;
            do {
                inext--;
                if ( inext == -1 ) {
                    // ѥʤȤޤΤǤ
                    if ( sw_not_cycled ) {
                        sw_not_cycled = false;
                        inext = pathtbl_back.number() - 1;
                    } else {
                        sw_nopath = true;
                        break;
                    }
                }
            } while ( tmpsel[ inext ].number() == 0
                      || hwyt[ inext ] < 0 );
            if ( sw_nopath ) {	// ѥʤ
                return ret_val;	// Υѥ֤
            }
            if ( tmpsel[ i ].number() == 0 ) {	// ѥҤȤĤʤ
                sw_reject = true;			// ꥸ

            } else if ( inext != i ) {	// ξʲԤ
                sw_end_pck = sw_end_pck && ckd[ i ][ inext ];
                if ( ckd[ i ][ inext ] ) continue;
                else ckd[ i ][ inext ] = true;
#ifdef OLDPATHSEARCH
                // ΥѥκǽΥФ
                // ѥʣɤǤ褤 [ 0 ][ 0 ] 
                PathCell nxcell = tmpsel[ inext ][ 0 ][ 0 ];

                // ߸ΥѥκǽΥФ
                PathCell currcell = tmpsel[ i ][ 0 ][ 0 ];

                // inext  i θ˲󤵤줿ʤ nxcell 1ʤޤ
                if ( ! sw_not_cycled ) nxcell--;

                // nxcell ȯֻ郎߸ΥѥΤ
                // ٤ä鸽ߤ֤ꥸȤ
                if ( nxcell.tm_dep > currcell.tm_dep )
                    sw_reject = true;
#else
                // ΥѥФ ʣɤǤ褤
                PathMap nxmp = tmpsel[ inext ][ 0 ];

                // ߸ΥѥФ
                PathMap currmp = tmpsel[ i ][ 0 ];

                // inext  i θ˲󤵤줿ʤ nxmp 1ʤޤ
                if ( ! sw_not_cycled ) {
                    for ( int xi = 0; xi < nxmp.number(); xi++ ) {
                        nxmp[ xi ]--;
                    }
                }

                // currmp  nxmp ͥ٤㤫äꥸȤ
                // nxmp ˤĤƤϡԤ֤˻֤ä
                currmp.backward_calculate_wait_time();
                currmp.backward_calculate_transfer();
                nxmp.backward_calculate_wait_time();
                nxmp.backward_calculate_transfer();
                nxmp.wait_time() += hwyt[ inext ];
                if ( sortpathmap_backward
                     ( ( const void* ) ( &currmp ),
                       ( const void* ) ( &nxmp ) )
                     > 0 ) {
                    sw_reject = true;
                }
#endif /* ! OLDPATHSEARCH */
            }

            // ꥸȤΤ: ֤򼡤֤­
            if ( sw_reject ) {
                hwyt[ inext ] += hwyt[ i ];
                hwyt[ i ] = -1;
            }
        }
    } while ( ! sw_end_pck );
    
    // 褤֤ͤκ
    static PathMap x;
    x.renew();
    for ( i = 0; i < pathtbl_back.number(); i++ ) {
        for ( register int j = 0; j < tmpsel[ i ].number(); j++ ) {
            if ( hwyt[ i ] < 0 ) continue;
            x = tmpsel[ i ][ j ];
            x.set_headway( hwyt[ i ] );
            x.set_trains_in_path( tmpsel[ i ].number() );
            ret_val += x;
        }
    }

    return ret_val;
}
