// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// PathSearch.hh --- header file that defines class PathSearch
// $Id: PathSearch.hh,v 4.0.1.1 1996/07/08 06:15:57 rt Exp $

#include "PathSearchCell.hh"
#include "BoolMatrix.hh"

#ifndef ___PATHSEARCH_HH
#define ___PATHSEARCH_HH

// ѥõθ³
// PATHSEARCHLIMIT * ؿ ޤǥ
#ifndef PATHSEARCHLIMIT
#define PATHSEARCHLIMIT 3
#endif

// ѥθ³
// PATHCANDIDATE ޤǥ
#ifndef PATHCANDIDATE
#define PATHCANDIDATE 10
#endif


class PathExistY: public RefTable< int > {
  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (PathExistY)\n";
    }
};

class PathExist: public RefTable< PathExistY > {
  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (PathExistX)\n";
    }
};


// ι BoolMatrix ֤ typedef ڤȴ
// class PathSearchedY: public RefTable< bool > {
//   private:
//     void error26_name() const {
//         cerr << "Error: subscript out of range (PathSearchedY)\n";
//     }
// };

// class PathSearched: public RefTable< PathSearchedY > {
//   private:
//     void error26_name() const {
//         cerr << "Error: subscript out of range (PathSearchedX)\n";
//     }
// };

typedef BoolMatrix PathSearched;


class PathSearch: public RefTable< PathSearchCell > {

  protected:
    PathMap fspm;		// ƥݥѥơ֥
    PathTable tmp_pathtbl;	// ƥݥѥơ֥
    PathTable tmp_finalpath;	// ƥݥѥơ֥
    PathMatrix path_forward;	// ѥ
    PathMatrix path_backward;	// ѥ
    PathMatrix path_candidate_forward;	// ѥ両
    PathMatrix path_candidate_backward;	// ѥ両
    PathExist pe;
    PathSearched psd;

  private:
    PathTblTbl pathtbl_forw;
    PathTblTbl pathtbl_back;

  public:

    // ѥơ֥λ
    PathTable& see_path_forward( int i, int j )
        {return path_forward[ i ][ j ];}
    // ѥη̤ϤΤ褦ˤҤä֤ʤФʤʤ
    PathTable& see_path_backward( int i, int j )
        {return path_backward[ j ][ i ];}

    // Ϣμ¸
    PathSearchCell& cell_arrival( PathCell& );		// Τ
    PathSearchCell& cell_departure( PathCell& );	// Τ
//     PathSearchCell& operator[]( int x )	// ĤΤϸߴΤ
//         { return RefTable< PathSearchCell >::operator[]( x ); }

    // ư
    void trf_set_trnum( int );			// Ƽ󥻥å
    void rd_transfertime( istream&, string& );	// 费ɹ
    void set_pathexistence( PathExist& x )	// ѥ¸߹ɹ
        {pe = x;}

    // ػɽκɽ
    void make_station_timetable();		// Ȥƴ
    void print_station_timetable( ostream& );	// ɽ

    // PathCell  PathSearchCell ΥХ֥Ȥɲ
    PathSearch& operator+=( PathCell& );	// arrival ɲ
    PathSearch& operator*=( PathCell& );	// departure ɲ

    // ѥξ
    bool pathsearched( int i, int j ) {return psd[ i ][ j ];}

  public:
    // ѥ
    void prepare_for_forward_search();
    void search_forward( ostream&, ostream& );
    void search_forward_ij( int, int, ostream& );	// ϥΤ
    void search_forward_ij( int, int, ostream&,		// 
                            ostream&, bool = true );	// եؤ
    PathTable&
    select_from_forward_path_table( int, int );		// ǽŪ
    bool search_forward_using_searched( ostream& );	/* ODڥ
                                                           ͭ */

  protected:
    // ѥΥ֥ץ
    void search_forward_sub( PathCell, int );
    void search_forward_sub( /* PathMap&, */ int, int = 0 );
    bool sw_searched_forward( /* const PathMap&, */ int );
    void add_fspm_in_forward_search();
    void connect_searched_path_forward( int );

  public:
    // ѥ
    void prepare_for_backward_search();
    void search_backward( ostream&, ostream& );
    void search_backward_ij( int, int, ostream&);	// ϥΤ
    void search_backward_ij( int, int, ostream&,	// 
                             ostream&, bool = true );	// եؤ
    void select_backward();
    PathTable& select_from_backward_path_table( int, int );
    bool search_backward_using_searched( ostream& );	/* ODڥ
                                                           ͭ */

  protected:
    // ѥΥ֥ץ
    void search_backward_sub( PathCell, int );
    void search_backward_sub( /* PathMap&, */ int, int = 0 );
    bool sw_searched_backward( /* const PathMap&, */ int );
    void add_fspm_in_backward_search();
    void connect_searched_path_backward( int );

  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (PathSearch)\n";
    }

  public:
    friend istream& operator>>( istream&, PathSearch& );
};

#endif /* ! ___PATHSEARCH_HH */
