// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// ReadData.cc --- class ReadData functions
// $Id: ReadData.cc,v 4.0 1996/07/08 06:10:48 rt Exp $

#include <stdio.h>
// #include <std.h>
// #include <string.h>
#include <ctype.h>
#include <stdarg.h>

#include "ReadData.hh"

static RegexContainer rgc;

// $B%G!<%?%U%!%$%k%(%i!<(B
ostream& err_eof_noexit( const string& nm ) {
    cerr << "Error: data file \"" << nm << "\" not correct";
    return cerr;
}

ostream& err_eof_noexit() {
    cerr << "Error: data file not correct";
    return cerr;
}

int check_eof( int chx, const string& nm ) {
    if ( chx ) {
        err_eof_noexit( nm );
        if ( chx == 1 )
            cerr << ": too many item(s)\n";
        else
            cerr << ": insufficient item(s)\n";
        exit ( 1 );
    }
    return 0;
}


void err_eof( const string& nm ) {
    err_eof_noexit( nm ) << "\n";
    exit( 1 );
}

void err_eof() {
    err_eof_noexit() << "\n";
    exit( 1 );
}

// $B%3%a%s%H9T8!=P(B
int comment_out
( istream& str ) {
    char c;
    c = str.get();
    if ( c == EOF ) return EOF;
  SHARP:
    if ( c == '#' ) {				// # $B$rH/8+$7$?$i(B
	while ( c != '\n' ) {			// $B9TKv$^$G6uFI$_(B
            c = str.get();
	    if ( c == EOF ) return EOF;
	}
        c = str.get();	// \n$B$N<!#1;zFI$`(B
	if ( c == EOF ) return EOF;
    } else if ( ! isspace( c ) ) goto ENDING;	// $B%9%Z!<%90J30$G$O=*N;(B
    while ( isspace( c ) ) {              	// $B%9%Z!<%9$bFI$_Ht$P$9(B
        c = str.get();
	if ( c == EOF ) return EOF;
    }

// # $BH/8+$7$?$iLa$k(B
//  BACK:	// -Wall warning: label defined but not used $B2sHr(B
    if ( c == '#' ) goto SHARP;

// $B=*N;(B
  ENDING:
    str.putback( c );			// c $B$r2!$7La$9(B
    return 1;
}

// $B%3%a%s%H9T8!=P(B, sw = false $B$G(B eof $B8!=P(B OK
int comment_out
( istream& str, const string& nm ) {
    if ( comment_out( str ) == EOF )
        err_eof( nm );
    return 1;
}

// $B%3%^%s%IL>$rF@$k(B
int getcommand
( istream& str, string& c ) {
    if ( comment_out( str ) == EOF )	// $B%3%a%s%H%"%&%H(B
        return EOF;
    if ( ! ( str >> c ) )		// $BFI$_9~$`(B
	return EOF;
    return 1;
}

// $B%3%^%s%IL>$rF@$k(B
int getcommand
( istream& str, const string& nm, string& c ) {
    if ( getcommand( str, c ) == EOF ) err_eof( nm );
    return 1;
}

// $BG\@:EY<B?t7?JQ?t$rF@$k(B
int getdouble
( istream& str, double& dbl ) {
    if ( comment_out( str ) == EOF ) return EOF;
    if ( ! ( str >> dbl ) ) return EOF;
    return 1;
}

// $BG\@:EY<B?t7?JQ?t$rF@$k(B
int getdouble
( istream& str, const string& nm, double& dbl ) {
    if ( getdouble( str, dbl ) == EOF ) err_eof( nm );
    return 1;
}

// $B@0?t7?JQ?t$rF@$k(B
int getint
( istream& str, int& ixx ) {
    if ( comment_out( str ) == EOF ) return EOF;
    if ( ! ( str >> ixx ) ) return EOF;
    return 1;
}

// $B@0?t7?JQ?t$rF@$k(B
int getint
( istream& str, const string& nm, int& ixx ) {
    if ( getint( str, ixx ) == EOF ) err_eof( nm );
    return 1;
}

// $B@0?t7?JQ?t$rJ8;zNs$+$iF@$k(B
int getintfromstring
( const string& str, int& ixx ) {
    istrstream xstr( str.c_str() );
    if ( comment_out( xstr ) == EOF ) return EOF;
    if ( ! ( xstr >> ixx ) ) return EOF;
    return 1;
}

// $BICC10L;~9o!J@0?t7?JQ?t!K$rF@$k(B
int getinttime
( istream& str, int& itm ) {
    size_t nm;
    regmatch_t* pm;
    string rstr;
    int x;
    itm = 0;
    if ( getcommand( str, rstr ) == EOF ) return EOF;
    if ( ! regexec( &(rgc.h_m_s), rstr.c_str(), nm, pm, REG_NOTBOL ) ) {
        string xstr = rstr.substr( 0, rstr.find( ":" ) );
        istrstream xistr( xstr.c_str() );
        xistr >> x;
        itm += x * 60 * 60;
        xstr = rstr.substr( rstr.find( ":" ) );
        rstr = xstr;
    }
    if ( ! regexec( &(rgc.m_s), rstr.c_str(), nm, pm, REG_NOTBOL ) ) {
        string ystr = rstr.substr( 0, rstr.find( ":" ) );
        istrstream yistr( ystr.c_str() );
        yistr >> x;
        itm += x * 60;
        ystr = rstr.substr( rstr.find( ":" ) );
        rstr = ystr;
    }
    istrstream zistr( rstr.c_str() );
    zistr >> x;
    itm += x;
    return 1;
}

// $BICC10L;~9o!J@0?t7?JQ?t!K$rF@$k(B
int getinttime
( istream& str, const string& nm, int& itm ) {
    if ( getinttime( str, itm ) == EOF ) err_eof( nm );
    return 1;
}
