// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// SchedEval.cc --- class SchedEval functions
// $Id: SchedEval.cc,v 4.0.1.3 1996/07/31 03:55:01 rt Exp $

#include "SchedEval.hh"
#include <math.h>
#include <iostream>
#include <iomanip>
#include <strstream.h>

#define SETTABLE_WIDTH 10
#define SETTABLE_COLWIDTH 6
#define SETTABLE_PREC 5

// ֥եɤ߹
int operator>>
( istream& istt, StandardTimeTable& x ) {

    // ֹ get
    if ( getint ( istt, x.id_stn_pivot ) == EOF ) return -1;

    for ( register int i = 0; i < x.number(); i++ ) {

        // id_stn_pivot ξϥեɤ߹ޤʤ
        if ( x.id_stn_pivot < 0 ) x[ i ] = 0;

        else if ( getinttime ( istt, x[ i ] ) == EOF ) return -1;
    }
    if ( ( comment_out( istt ) != EOF ) ) return 1;
    return 0;
}


int operator>>
( istream& iother, SchedEval& x ) {

    // ե̾
    if ( getcommand ( iother, x.fn_eo ) == EOF ) return -1;
    if ( getcommand ( iother, x.fndia ) == EOF ) return -1;
    if ( getcommand ( iother, x.fnstn ) == EOF ) return -1;
    if ( getcommand ( iother, x.fnlmp ) == EOF ) return -1;
    if ( getcommand ( iother, x.fntrf ) == EOF ) return -1;
    if ( getcommand ( iother, x.fnstt ) == EOF ) return -1;
    if ( getcommand ( iother, x.fnpth ) == EOF ) return -1;
    if ( getcommand ( iother, x.fnplg ) == EOF ) return -1;
    if ( getcommand ( iother, x.fnstd ) == EOF ) return -1;
    if ( getcommand ( iother, x.fnod1 ) == EOF ) return -1;
    if ( getcommand ( iother, x.fnod2 ) == EOF ) return -1;
    if ( getcommand ( iother, x.fntrc ) == EOF ) return -1;
//     if ( getcommand ( iother, x.fncon ) == EOF ) return -1;
#ifndef NOSTNCONGES
    if ( getint ( iother, x.istc ) == EOF ) return -1;
    cerr << "ع⺮٤";
    if ( x.istc < 0 ) {
        cerr << "׻ʤ\n";
    } else {
        cerr << setw(3) << setfill(' ') << x.istc << "ؤˤĤƷ׻\n";
        if ( getcommand ( iother, x.fnstc ) == EOF ) return -1;
    }
#endif /* ! NOSTNCONGES */

    // եȥμ
    string grstr;
    if ( getcommand ( iother, grstr ) == EOF ) return -1;
    cerr << "Graph tool assumed in data files: ";
    if ( grstr == "gnuplot" ) {
        x.gr = Gnuplot;
        cerr << "GNUPLOT\n";
    } else if ( grstr == "xgraph" ) {
        x.gr = Xgraph;
        cerr << "Xgraph\n";
    } else {
        cerr << "\n...Oops, I do not know about the tool named \""
             << grstr << "\"! Exiting...\n";
        exit( 1 );
    }
    int wariai;

    // »֤Фɾ (/ʬ)
    if ( getint ( iother, wariai ) == EOF ) return -1;
    x.r1 = wariai / 60.0;
    cerr << "»֤Фɾ: " << wariai << "(/ʬ)\n";

    // 괹ˤ»ʱߡ
    if ( getint ( iother, wariai ) == EOF ) return -1;
    x.r2 = wariai;
    cerr << "괹ˤ»: " << wariai << "(/)\n";

    // Ωʻ֤ˤ»ʱߡʬ
    if ( getint ( iother, wariai ) == EOF ) return -1;
    x.r3 = wariai / 60.0;
    cerr << "Ωʻ֤ˤ»: " << wariai << "(/ʬ)\n";

    // 费֤ˤ»ʱߡʬ: »ʬʬˡɲá
    if ( getint ( iother, wariai ) == EOF ) return -1;
    x.r4 = wariai / 60.0;
    cerr << "费֤ˤɲ»: " << wariai << "(/ʬ)\n";

    // Ԥ֤ˤ»ʱߡʬ: »ʬʬˡɲá
    if ( getint ( iother, wariai ) == EOF ) return -1;
    x.r5 = wariai / 60.0;
    cerr << "Ԥ֤ˤɲ»: " << wariai << "(/ʬ)\n";

    if ( ( comment_out( iother ) != EOF ) ) return 1;
    return 0;
}

// ǡ꡼ɤȽä˱ػɽС
void
SchedEval::dataread() {
    ifstream idia( fndia.c_str() );
    ifstream istn( fnstn.c_str() );
    ifstream ilmp( fnlmp.c_str() );
    ifstream itrf( fntrf.c_str() );
    ifstream istd( fnstd.c_str() );
    ofstream ostt( fnstt.c_str() );

    // ؾ
    check_eof( ( istn >> stn ), fnstn );

    // ϩȱֹξȹ
    check_eof( ( ilmp >> lmap ), fnlmp );
    lmap.check_station_range( stn.number(), fnlmp, fnstn );
    
    // ֥
    check_eof( ( idia >> dia ), fndia );

    // LineMap, PathSearch ֥Ȥν
    psh.setnum( stn.number() );
    psh.trf_set_trnum( dia.number() );
    psh.rd_transfertime( itrf, fntrf );
    lmap.prepare_section_data_cells( dia, fnlmp, fndia );

    pe.setnum( stn.number() );
    register int i;
    for ( i = 0; i < pe.number(); i++ ) {
        pe[ i ].setnum( stn.number() );
    }

    dia.reachability_search( pe );
    psh.set_pathexistence( pe );

    dia.transfer_station_timetable( psh );
    psh.make_station_timetable();
    psh.print_station_timetable( ostt );
    ostt.close();

//     psh.path_set_stnum();

    ifstream idod( fnod1.c_str() );

    od_f1.set_stations( stn.number() );

    check_eof( ( idod >> od_f1 ), fnod1 );
    od_f1.settable
        ( SETTABLE_WIDTH, SETTABLE_COLWIDTH, SETTABLE_PREC );
    cerr << "****  F1  OD ****\n" << od_f1;

    idod.close();
    idod.open( fnod2.c_str() );

    od_f2.set_stations( stn.number() );
    check_eof( ( idod >> od_f2 ), fnod2 );
    od_f2.settable
        ( SETTABLE_WIDTH, SETTABLE_COLWIDTH, SETTABLE_PREC );
    cerr << "\n****  F2  OD ****\n" << od_f2;
    cerr << "**** ֿͰ: " << total_number_of_passengers()
         << " ****\n\n";

    stdt.setnum( stn.number() );
    check_eof( ( istd >> stdt ), fnstd );
}


// ѥեΥץ
void
SchedEval::path_search_file_open
() {
    opth.open( fnpth.c_str() );
    oplg.open( fnplg.c_str() );
}


// ѥեΥ
void
SchedEval::path_search_file_close
() {
    opth.close();
    oplg.close();
}


// ѥ
void
SchedEval::path_search_forward
() {
    psh.prepare_for_forward_search();
    cerr << "**** ܴطѤľѥõ\n";
    register int ix;
    for ( ix = 0; ix < stn.number(); ix++ ) {
        cerr << ix << " ";
        for ( int j = stn.number() - ix - 1; j >= 0; j-- ) {
            psh.search_forward_ij( j, j + ix, oplg );
        }
    }
    cerr << "\n";
    cerr << "**** ܴطѤľѥõλޤ\n\n";
    cerr << "**** ֤Ȥľѥõ\n";
    register int i;
    for ( i = 0; i < dia.number(); i++ ) {
        cerr << i << ": ";
        for ( ix = 0; ix < dia[ i ].number(); ix++ ) {
            cerr << ix << " ";
            for ( int j = dia[ i ].number() - ix - 1; j >= 0; j-- ) {
                psh.search_forward_ij
                    ( dia[ i ][ j ].id_stn_dep,
                      dia[ i ][ j + ix ].id_stn_arr,
                      oplg );
            }
        }
        cerr << "\n";
    }
    cerr << "**** ֤Ȥľѥõλޤ\n\n";
    cerr << "**** ѥͭ\n-- ";
    for ( i = 0; i < PATHSEARCH_USING_CIRC; i++ ) {
        cerr << i + 1 << " ";
        if ( psh.search_forward_using_searched( oplg ) )
            break;
    }
    cerr << "**** ѥͭλޤ\n\n";
    psh.search_forward( opth, oplg );
}


// ѥ
void
SchedEval::path_search_backward
() {
    psh.prepare_for_backward_search();
    cerr << "**** ܴطѤľѥõ\n";
    register int ix;
    for ( ix = 0; ix < stn.number(); ix++ ) {
        cerr << ix << " ";
        for ( int j = 0; j < stn.number() - ix; j++ ) {
            psh.search_backward_ij( j + ix, j, oplg );
        }
    }
    cerr << "\n";
    cerr << "**** ܴطѤľѥõλޤ\n\n";
    cerr << "\n**** ֤Ȥθľѥõ\n";
    register int i;
    for ( i = 0; i < dia.number(); i++ ) {
        cerr << i << ": ";
        for ( ix = 0; ix < dia[ i ].number(); ix++ ) {
            cerr << ix << " ";
            for ( int j = 0; j < dia[ i ].number() - ix; j++ ) {
                psh.search_backward_ij
                    ( dia[ i ][ j + ix ].id_stn_arr,
                      dia[ i ][ j ].id_stn_dep,
                      oplg );
            }
        }
        cerr << "\n";
    }
    cerr << "**** ֤Ȥθľѥõλޤ\n\n";
    cerr << "**** ѥͭѸ\n-- ";
    for ( i = 0; i < PATHSEARCH_USING_CIRC; i++ ) {
        cerr << i + 1 << " ";
        if ( psh.search_backward_using_searched( oplg ) )
            break;
    }
    cerr << "**** ѥͭѸλޤ\n\n";
    psh.search_backward( opth, oplg );
}


// OD ֤ؤγդ
void
SchedEval::distribute_forward_od
() {
    total_loss_time = total_wait_time = total_transfer_time
        = total_transfer_occasions = 0;
    for ( int i = 0; i < stn.number(); i++ ) {
        for ( int j = 0; j < stn.number(); j++ ) {

            // ȯؤƱ㤷礦ʤΤ
            if ( i == j ) continue;

            // ѥơ֥ȯ˹Ԥ
            PathTable x = psh.see_path_forward( i, j );

            for ( int k = 0; k < x.number(); k++ ) {
                // ֿͿη׻
                double np = double( od_f1( i, j ) );
                np *= double( x[ k ].headway() );
                np /= double( dia.get_cycle() )
                    * double( x[ k ].trains_in_path() );
                int i_np = int ( floor( np + 0.5 ) );
                
                // ĤǤˡٻ֡ʤɤη׻
                total_wait_time += i_np			// Ԥ֤ˤ
                    * ( x[ k ].wait_time()		// ֤Ȥλ
                        + x[ k ].headway() / 2 );	// Ⱦʬä
                total_transfer_time += i_np * x[ k ].transfer_time();
                total_transfer_occasions
                    += i_np * x[ k ].transfer_occasions();

                // »֤η׻Ϥä
                // Ԥ֤Ⱦ费֤ʬƷ׻
                // ʾäƤ֤
                int tm_loss = x[ k ].last().tm_arr;
                tm_loss -= x[ k ][ 0 ].tm_dep;
                tm_loss -= x[ k ].wait_time() + x[ k ].transfer_time();
                total_loss_time += i_np * tm_loss;

                // ǡ˿Ϳ­
                for ( int l = 0; l < x[ k ].number(); l++ ) {
                    dia[ x[ k ][ l ] ].num_passen += i_np;
                    if ( l < x[ k ].number() - 1 &&
                         x[ k ][ l ] != x[ k ][ l + 1 ] ) {
                        psh.cell_arrival( x[ k ][ l ] )
                            .arrival_trf_num( x[ k ][ l ], i_np );
                        psh.cell_departure( x[ k ][ l + 1 ] )
                            .departure_trf_num( x[ k ][ l + 1 ], i_np );
                    }
                }
            }
        }
    }
}


// OD ֤ؤγդ
void
SchedEval::distribute_backward_od
() {
    // total_loss_time, total_wait_time, total_transfer_time,
    // total_transfer_occasions ΥꥻåȤ
    // distribute_forward_od() ؿˤǤ

    for ( int i = 0; i < stn.number(); i++ ) {
        for ( int j = 0; j < stn.number(); j++ ) {

            // ȯؤƱ㤷礦ʤΤ
            if ( i == j ) continue;

            // ѥơ֥ȯ˹Ԥ
            PathTable x = psh.see_path_backward( i, j );

            for ( int k = 0; k < x.number(); k++ ) {
                // ֿͿη׻
                double np = double( od_f2( i, j ) );
                np *= double( x[ k ].headway() );
                np /= double( dia.get_cycle() )
                    * double( x[ k ].trains_in_path() );
                int i_np = int ( floor( np + 0.5 ) );
                
                // ĤǤˡٻ֡ʤɤη׻
                total_wait_time += i_np			// Ԥ֤ˤ
                    * ( x[ k ].wait_time()		// ֤Ȥλ
                        + x[ k ].headway() / 2 );	// Ⱦʬä
                total_transfer_time += i_np * x[ k ].transfer_time();
                total_transfer_occasions
                    += i_np * x[ k ].transfer_occasions();

                // »֤η׻Ϥä
                // Ԥ֤Ⱦ费֤ʬƷ׻
                // ʾäƤ֤
                int tm_loss = x[ k ].last().tm_arr;
                tm_loss -= x[ k ][ 0 ].tm_dep;
                tm_loss -= x[ k ].wait_time() + x[ k ].transfer_time();
                total_loss_time += i_np * tm_loss;

                // ǡ˿Ϳ­
                for ( int l = 0; l < x[ k ].number(); l++ ) {
                    dia[ x[ k ][ l ] ].num_passen += i_np;
                    if ( l < x[ k ].number() - 1 &&
                         x[ k ][ l ] != x[ k ][ l + 1 ] ) {
                        psh.cell_arrival( x[ k ][ l ] )
                            .arrival_trf_num( x[ k ][ l ], i_np );
                        psh.cell_departure( x[ k ][ l + 1 ] )
                            .departure_trf_num( x[ k ][ l + 1 ], i_np );
                    }
                }
            }
        }
    }
}
                

// ֤ɾ̻
void
SchedEval::calculate_train_evals
() {
    car_hour = train_hour = 0;
    total_loss_stand = 0.0;

    register int i;
    for ( i = 0; i < dia.number(); i++ )
    {
        // ޤ car hour Ω»
        int ctim;
        for ( int j = 0; j < dia[ i ].number() - 1; j++ )
        {
            ctim = dia[ i ][ j + 1 ].tm_dep
                + stdt[ dia[ i ][ j + 1 ].id_stn_dep ];
            ctim -= dia[ i ][ j ].tm_dep
                + stdt[ dia[ i ][ j ].id_stn_dep ];
            car_hour += ctim * dia[ i ][ j ].num_cars;
            dia[ i ][ j ].loss_stand = double( ctim ) * r3 *
                ( dia[ i ][ j ].num_passen - dia[ i ][ j ].cap_seat );
            if ( dia[ i ][ j ].loss_stand < 0.0 ) {
                dia[ i ][ j ].loss_stand = 0.0;
            }
            total_loss_stand += dia[ i ][ j ].loss_stand;
        }
        ctim = dia[ i ].last().tm_arr
            + stdt[ dia[ i ].last().id_stn_arr ];
        ctim -= dia[ i ].last().tm_dep
            + stdt[ dia[ i ].last().id_stn_dep ];
        car_hour += ctim * dia[ i ].last().num_cars;
        dia[ i ].last().loss_stand = double( ctim ) * r3 *
            ( dia[ i ].last().num_passen - dia[ i ].last().cap_seat );
        if ( dia[ i ].last().loss_stand < 0.0 ) {
            dia[ i ].last().loss_stand = 0.0;
        }
        total_loss_stand += dia[ i ].last().loss_stand;

        // ³ train hour
        ctim = dia[ i ].last().tm_arr
            + stdt[ dia[ i ].last().id_stn_arr ];
        ctim -= dia[ i ][ 0 ].tm_dep
            + stdt[ dia[ i ][ 0 ].id_stn_dep ];
        train_hour += ctim;
    }
    loss_stand_pp = total_loss_stand / total_number_of_passengers();

    // ٤ޤ
    for ( i = 0; i < dia.number(); i++ ) {
        if ( dia[ i ].number() == 0 ) continue;
        max_1 = max_2 = max_3 = max_4 = max_5
            = &( dia[ i ][ 0 ] );
        break;
    }
    for ( i = 0; i < dia.number(); i++ ) {
        for ( int j = 0; j < dia[ i ].number(); j++ ) {
            dia[ i ][ j ].cong_rate
                = double( dia[ i ][ j ].num_passen )
                / double( dia[ i ][ j ].capacity );

            // ĤǤ˺Ǻ֤Ф
            if ( dia[ i ][ j ].cong_rate >= max_1->cong_rate ) {
                max_5 = max_4;
                max_4 = max_3;
                max_3 = max_2;
                max_2 = max_1;
                max_1 = &( dia[ i ][ j ] );
            } else if ( dia[ i ][ j ].cong_rate >= max_2->cong_rate ) {
                max_5 = max_4;
                max_4 = max_3;
                max_3 = max_2;
                max_2 = &( dia[ i ][ j ] );
            } else if ( dia[ i ][ j ].cong_rate >= max_3->cong_rate ) {
                max_5 = max_4;
                max_4 = max_3;
                max_3 = &( dia[ i ][ j ] );
            } else if ( dia[ i ][ j ].cong_rate >= max_4->cong_rate ) {
                max_5 = max_4;
                max_4 = &( dia[ i ][ j ] );
            } else if ( dia[ i ][ j ].cong_rate >= max_5->cong_rate ) {
                max_5 = &( dia[ i ][ j ] );
            }
        }
    }
    // ¸٤η׻ LineData 饹˰ư
    lmap.extract_congestion_data( dia );
    lmap.calculate_congestion();
}


void
SchedEval::congesout
( ostream& outx, int iord, const TrainSchedCellEval* max  )
{
    outx << iord << ": " << max->id_tr << ": "
         << stn[ max->id_stn_dep ].name_kanji() << " -> "
         << stn[ max->id_stn_arr ].name_kanji() << "\n";
    outx << "   Ψ  " /* << setw(7) << setfill(' ') */ << setprecision(4)
         << max->cong_rate * 100 << setw(0) << "(), Ω»  "
      /* << setw(8) << setfill(' ') */ << setprecision(6) << max->loss_stand
         << setw(0) << "\n";
}


void
SchedEval::stncongesout
() {
    if ( istc < 0 ) {	// عαҿ׻Ϥʤ
        return;		// äƤʤˤ⤻꥿
    }
    StationTimeTable stc = psh[ istc ].get_transfer_numbers();
    int ivmn = 0;
    int ixmn = 0;
    int imn = 0;
    int i;
    for ( i = 0; i < stc.number(); i++ ) {
        ixmn += stc[ i ].num_passen;
        if ( ixmn < ivmn ) {
            ivmn = ixmn;
            imn = i;
        }
    }
    imn++;
    if ( imn >= stc.number() ) imn -= stc.number();

    ofstream ostc( fnstc.c_str() );
    if ( gr == Gnuplot ) {
        string dfnstc = fnstc + ".Xdata";
        ostc << "plot \"" << dfnstc << "\" w lines\n";
        ostc.close();
        ostc.open( dfnstc.c_str() );
    }
    ixmn = 0;
    for ( i = 0; i < stc.number(); i++ ) {
        bool sw_cycle = false;
        int j = i + imn;
        if ( j >= stc.number() ) {
            j -= stc.number();
            sw_cycle = true;
        }
        PathCell x = stc[ j ];
        if ( sw_cycle ) x++;
        ostc << x.tm_arr << " " << ixmn << "\n";
        ixmn += x.num_passen;
        ostc << x.tm_arr << " " << ixmn << "\n";
    }
    int j = i + imn;
    bool sw_cycle = false;
    if ( j >= stc.number() ) {
        j -= stc.number();
        sw_cycle = true;
    }
    PathCell x = stc[ j ];
    if ( sw_cycle ) x++;
    ostc << x.tm_arr << " " << ixmn << "\n";
    ostc.close();
}


// 
void
SchedEval::output
() {
  ofstream oout ( fn_eo.c_str() );
  oout << "***** ɾ *****\n\n";
  loss_time_pp = double( total_loss_time )
    / double( total_number_of_passengers() );
  oout << "»: " /* << setw(8) << setfill(' ') */ << setprecision(5)
       << loss_time_pp << setw(0) << "/\n";
  wait_time_pp = double( total_wait_time )
    / double( total_number_of_passengers() );
  oout << "Ԥ: " /* << setw(8) << setfill(' ') */ << setprecision(5)
       << wait_time_pp << setw(0) << "/\n";
  transfer_occasions_pp = double( total_transfer_occasions )
    / double( total_number_of_passengers() );
  oout << "费: " /* << setw(8) << setfill(' ') */ << setprecision(4)
       << transfer_occasions_pp << setw(0) << "/\n";
  transfer_time_pp = double( total_transfer_time )
    / double( total_number_of_passengers() );
  oout << "费: " /* << setw(8) << setfill(' ') */ << setprecision(5)
       << transfer_time_pp << setw(0) << "/\n\n";
  // ¸ٴϢ LineMap ֥Ȥ˰ư
  lmap.congesout( oout );
  oout << "     (ֺ٥եǡ " << fntrc << " ե)\n";
  graphout();
  oout << "\n:     " << setprecision(4)
    // << setw(7) << setfill(' ') 
       << double( car_hour ) / dia.get_cycle() << "ξ\n";
  oout << "ȥ쥤󥢥: " << setprecision(4)
    // << setw(7) << setfill(' ') 
       << double( train_hour ) / dia.get_cycle() << "\n\n";
  oout << "Ǻ֤ȶ:\n";
  congesout( oout, 1, max_1 );
  congesout( oout, 2, max_2 );
  congesout( oout, 3, max_3 );
  congesout( oout, 4, max_4 );
  congesout( oout, 5, max_5 );
#ifndef NOSTNCONGES
  stncongesout();
#endif /* ! NOSTNCONGES */
  oout << "\n*** ۴ɾ:\n";
  oout << "--- ֻʬĶˤˤ»: "
    /* << setw(8) << setfill(' ') */ << setprecision(5)
       << r1 * loss_time_pp << setw(0) << "(/)\n";
  oout << "--- 费Ф»:       "
    /* << setw(8) << setfill(' ') */ << setprecision(5)
       << r2 * transfer_occasions_pp << setw(0) << "(/)\n";
  oout << "--- ΩʤФ»:           "
    /* << setw(8) << setfill(' ') */ << setprecision(5)
       << loss_stand_pp << setw(0) << "(/)\n";
  oout << "--- Ԥ֤Ф»:       "
    /* << setw(8) << setfill(' ') */ << setprecision(5)
       << ( r1 + r5 ) * wait_time_pp << setw(0) << "(/)\n";
  oout << "--- 费֤Ф»:       "
    /* << setw(8) << setfill(' ') */ << setprecision(5)
       << ( r1 + r4 ) * transfer_time_pp << setw(0) << "(/)\n";
  oout << "*** »ʾ嵭ס:     "
    /* << setw(8) << setfill(' ') */ << setprecision(5)
       << r1 * loss_time_pp + r2 * transfer_occasions_pp
    + loss_stand_pp + ( r1 + r5 ) * wait_time_pp
    + ( r1 + r4 ) * transfer_time_pp << setw(0) << "(/)\n";
  oout.close();
}
    
// ս񤭥ǡ
void
SchedEval::graphout
() {
    // ޤϼ¸٥
    // ʬ LineData ֥Ȥ˰ư
    if ( gr == Gnuplot ) {
        lmap.graphout_gnuplot();
    } else {
        lmap.graphout_xgraph();
    }
//     ofstream ogr( fncon );
//     if ( gr == Gnuplot ) {
//         string dfncon = fncon + ".Xdata";
//         ogr << "plot \"" << dfncon << "\" w lines\n";
//         ogr.close();
//         ogr.open( dfncon );
//     }
//     bool sw_first = true;
//     int i;
//     for ( i = 0; i < conges.number() - 1; i++ ) {
//         if ( sw_first ) {
//             ogr << i << " " << 0 << "\n";
//             sw_first = false;
//         }
//         ogr << i << " "
//             << conges[ i ] / num_passen[ i ] * 100 << "\n";
//         ogr << i + 1 << " "
//             << conges[ i ] / num_passen[ i ] * 100 << "\n";
//     }
//     ogr << i << " " << 0 << "\n";
//     ogr.close();

    // ֺ٥
    ofstream ogr( fntrc.c_str() );
    string x;
    register int i;
    bool sw_first = true;
    if ( gr == Gnuplot ) {
        bool sw_nofirst = false;
        for ( i = 0; i < dia.number(); i++ ) {
            ostrstream str;
            str << fntrc << "." << setw(3) << setfill('0')
                << i << setw(0) << '\0';
            str.freeze();
            x = str.str();
            if ( sw_nofirst ) {
                ogr << ", \\\n";
            } else {
                ogr << "plot ";
                sw_nofirst = true;
            }
            ogr << "\"" << x << "\" w lines";
            str.~ostrstream();
        }
        ogr << "\n";
    }
    for ( i = 0; i < dia.number(); i++ ) {
        ostrstream str;
        if ( gr == Gnuplot ) {
            ogr.close();
            str << fntrc << "." << setw(3) << setfill('0')
                << i << setw(0) << '\0';
            str.freeze();
            x = str.str();
            ogr.open( x.c_str() );
        } else {
            str << "\"Train " << setw(3) << setfill('0')
                << i << setw(0) << "\"" << '\0';
            str.freeze();
            x = str.str();
            ogr << "\n" << x << "\n";
        }            
        str.~ostrstream();
        sw_first = true;
        int j;
        for ( j = 0; j < dia[ i ].number(); j++ ) {
            if ( sw_first ) {
                ogr << dia[ i ][ j ].id_stn_dep << " " << 0 << "\n";
                sw_first = false;
            }
            ogr << dia[ i ][ j ].id_stn_dep << " "
                << dia[ i ][ j ].cong_rate * 100 << "\n";
            ogr << dia[ i ][ j ].id_stn_arr << " "
                << dia[ i ][ j ].cong_rate * 100 << "\n";
        }
        if ( j > 0 ) 
            ogr << dia[ i ].last().id_stn_arr << " " << 0 << "\n";
    }
    ogr.close();
}
            


// ɾ
void
SchedEval::evaluation
() {
    dataread();
    path_search_file_open();
    path_search_forward();
    path_search_backward();
    path_search_file_close();
    distribute_forward_od();
    distribute_backward_od();
    calculate_train_evals();
    output();
}
