// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// SchedEval.hh --- header file that defines class DiagramData
// $Id: SchedEval.hh,v 4.0.1.1 1996/07/08 08:38:56 rt Exp $

#include "GlobalSched.hh"
#include "PathMap.hh"
#include "ODMap.hh"
#include "StationData.hh"
#include "LineMap.hh"
#include <fstream.h>

#ifndef ___SCHEDEVAL_HH
#define ___SCHEDEVAL_HH


// ãǽθξ
#ifndef PATHSEARCH_USING_CIRC
#define PATHSEARCH_USING_CIRC 20
#endif /* ! PATHSEARCH_USING_CIRC */


// ս񤭥եȥμ
enum GraphSoftware {
    Xgraph, Gnuplot
};


// ֥ǡǼ֥
// αؤˤλȥǡʤɤ˵Ҥ줿Ȥκʬ
// »֤γǰ¸뤿ɬ
// λΤꤿˤͤ­
class StandardTimeTable: public RefTable< int > {
  protected:
    int id_stn_pivot;	// 

  public:
    StandardTimeTable(): RefTable< int >() {id_stn_pivot = 0;}

    // եɤ߹ߴؿ (int ֤ΤϤ褯ʤ)
    // ֤ͤϥǡ: 1=¿᤮ 0=Ŭ -1=ʲ᤮
    friend int operator>>( istream&, StandardTimeTable& );

    int pivot() {return id_stn_pivot;}

  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (StandardTimeTable)\n";
    }
};    

class SchedEval {

  private:
    // ե꡼
    string fn_dm;	// ǡޥե̾
    string fn_eo;	// ɾϥե̾
    string fndia;	// ǡɤ߹ѥե̾
    string fnstn;	// إǡɤ߹ѥե̾
    string fnlmp;	// ϩǡɤ߹ѥե̾
    string fntrf;	// 费֥ǡɤ߹ѥե̾
    string fnstt;	// ػɽ񤭽Фѥե̾
    string fnstd;	// ֥ǡե̾
    string fnpth;	// ѥ񤭽Фѥե̾
    string fnplg;	// ѥե̾

    string fnod1;	// F1 ODǡɤ߹ѥե̾
    string fnod2;	// F2 ODǡɤ߹ѥե̾

    GraphSoftware gr;	// ս񤭥եȥμ

    // ե饤
    ofstream opth;	// ѥϥե
    ofstream oplg;	// ѥե
//     string fndgo;	// 䥰Ļ벽ѥեǡե̾
    string fntrc;	// ֺΨѥǡե̾
//     string fncon;	// ¸Ψѥǡե̾
    string fnstc;	// عαͿѥǡե̾

  protected:
    // ֥
    StationData stn;		// إǡ
    GlobalSched dia;		// ǡ
    LineMap lmap;		// ϩǡ(ν)
    PathSearch psh;		// ǡ
    StandardTimeTable stdt;	// ֥ǡ
    PathExist pe;		// ѥ¸߹
    ODMap od_f1;		//  F1  OD ǡ
    ODMap od_f2;		//  F2  OD ǡ

    // ع⺮٤ɾ٤
    int istc;

    // ɾѷ
    double r1;			// »֤Фɾ (/)
    double r2;			// 费ˤ» (/)
    double r3;			// Ωʻ֤ˤ» (/)
    double r4;			// 费֤ˤ» (/)
    double r5;			// Ԥ֤ˤ» (/)

    // ɾѿ
    int total_loss_time;	    // »
    int total_wait_time;	    // Ԥ
    int total_transfer_time;	    // پ费
    int total_transfer_occasions;   // پ费
    double total_loss_stand;	    // Ω»
    double loss_time_pp;	    // ͤ»
    double wait_time_pp;	    // ͤԤ
    double transfer_time_pp;	    // ͤ费
    double transfer_occasions_pp;   // ͤ费
    double loss_stand_pp;	    // ͤΩ»
    int car_hour;		// ȥ쥤󥢥
    int train_hour;		// 
//     RefTable< double > conges;	// ¸
//     RefTable< double > num_passen;	// ¸ٷ׻Τ̲Ͱ
    const TrainSchedCellEval* max_1;	// 1Ǻ֡
    const TrainSchedCellEval* max_2;	// 2Ǻ֡
    const TrainSchedCellEval* max_3;	// 3Ǻ֡
    const TrainSchedCellEval* max_4;	// 4Ǻ֡
    const TrainSchedCellEval* max_5;	// 5Ǻ֡

  public:

    void dataread();			// Ƽǡ꡼

    void path_search_file_open();	// ѥѥե륪ץ
    void path_search_file_close();	// ѥѥե륯
    void path_search_forward();		// ѥ
    void path_search_backward();	// ѥ

    void distribute_forward_od();	// OD ֤ؤγդ
    void distribute_backward_od();	// OD ֤ؤγդ

    void calculate_train_evals();	// ִطɾ

    void output();		// 

    void evaluation();		// ɾ

    double total_number_of_passengers()
        {return od_f1.total() + od_f2.total();}

  public:
    friend int operator>>( istream&, SchedEval& );
    friend ostream& operator<<( ostream&, SchedEval& );

  private:
    void congesout( ostream&, int,		    // Ǻ֤
                    const TrainSchedCellEval* );    // ֤ɽ
    void graphout();		// ս񤭥ġ
    void stncongesout();	// ع⺮ٽ
};

#endif /* ! ___SCHEDEVAL_HH */
