// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// SectionData.hh --- header file that defines class SectionData
// $Id: SectionData.hh,v 4.0.1.2 1996/07/08 08:38:56 rt Exp $

#include <stdio.h>
// #include <std.h>
// #include <string.h>
#include <ctype.h>
#include <stdarg.h>

#include <string>
#include <iostream.h>
#include <iomanip.h>

#include "TrainSchedCell.hh"
#include "GlobalSched.hh"
#include "RefTable.hh"

#ifndef ___SECTIONDATA_HH
#define ___SECTIONDATA_HH


// ֤Ȥ֤˴ؤ
struct TrainRunningOnSectionDataCell {
    int id_tr;			// ֹ
    int id_ssr;			// ֤βܤ Start-to-Stop Run ?
    const TrainSchedCellEval* evals;	// ɬפɾ
};
    

// ־
class SectionData:
public RefTable< TrainRunningOnSectionDataCell > {

  protected:
    int id_stn_st;	// ¦ֹ
    int id_stn_end;	// ¦ֹ
    double cong;	// ¸
    double n_psg;	// ҿ

  public:

    SectionData(): RefTable< TrainRunningOnSectionDataCell >() {
        id_stn_st = id_stn_end = 0;
        cong = n_psg = 0.0;
    }

    SectionData( const SectionData& x ):
    RefTable< TrainRunningOnSectionDataCell >( x ) {
        membercopy( x );
    }

    SectionData& operator=( const SectionData& x ) {
        if ( &x == this ) return *this;
        RefTable< TrainRunningOnSectionDataCell >::operator=( x );
        membercopy( x ); return *this;
    }

    // ؤȻ
    void set_stations( int id_prev, int id_post ) {
        id_stn_st = id_prev;	id_stn_end = id_post;}
    int starting_station() {return id_stn_st;}
    int ending_station() {return id_stn_end;}

    // Ψη׻Ȼ
    void add_congestion_data( double cgr, double dnpsg )
        {cong += cgr * dnpsg;	n_psg += dnpsg;}
    double congestion() {return cong / n_psg * 100.0;}

    // ܴطγǧ
    bool is_next_to_ending_station_of( SectionData& x ) {
        if ( id_stn_st != x.ending_station() ) return false;
        else return true;
    }
    bool is_next_to_starting_station_of( SectionData& x ) {
        if ( id_stn_end != x.starting_station() ) return false;
        else return true;
    }

    // ¸٤뤿ΥǡФӼºݤη׻
    void extract_congestion_data( GlobalSched& );
    void calculate_congestion();

  private:
    void error26_name() const {
        cerr << "Error: subscript out of range (SectionData)\n";
    }

    void membercopy( const SectionData& x ) {
        id_stn_st = x.id_stn_st;	id_stn_end = x.id_stn_end;
        cong = x.cong;			n_psg = x.n_psg;
    }
};
    

#endif /* ! ___SECTIONDATA_HH */
