// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// StationData.hh --- header file that defines class StationData
// $Id: StationData.hh,v 4.0.1.1 1996/07/08 08:37:22 rt Exp $

#include <stdio.h>
// #include <std.h>
// #include <string.h>
#include <ctype.h>
#include <stdarg.h>

#include <string>
#include <iostream.h>
#include <iomanip.h>

#include "ReadData.hh"
#include "RefTable.hh"
#include <iomanip.h>

#ifndef ___STATIONDATA_HH
#define ___STATIONDATA_HH


class StationDataCell {

  protected:
    int id_st;		// ֹ
    string romaji;	// ̾ʥ޻
    string katakana;	// ̾ʥʡ
    string kanji;	// ̾ʴ

  public:
    StationDataCell()
    : romaji(), katakana(), kanji() { id_st = 0; }

    StationDataCell( const StationDataCell& x )
    : romaji( x.romaji ), katakana( x.katakana ), kanji( x.kanji )
        { id_st = x.id_st; }

    StationDataCell& operator=( const StationDataCell& x ) {
        if ( &x == this ) return *this;
        membercopy( x );
        return *this;
    }

    string name_kanji() {return kanji;}
    string name_romaji() {return romaji;}
    string name_katakana() {return katakana;}

    void set_id( int i ) {id_st = i;}

  private:
    void membercopy( const StationDataCell& x ) {
        id_st = x.id_st;	romaji = x.romaji;
        katakana = x.katakana;	kanji = x.kanji;
    }        

  public:
    friend ostream& operator<< ( ostream&, StationDataCell& );

    // եɤ߹ߴؿ (int ֤ΤϤ褯ʤ)
    // ֤ͤϥǡ: 1=¿᤮ 0=Ŭ -1=ʲ᤮
    friend int operator>> ( istream&, StationDataCell& );
};   /* formerly "ekimei" */



class StationData: public RefTable< StationDataCell > {

  public:

    void trf_set_trnum( int );		// 󥻥å
    void rd_transfertime( istream& );

    // եɤ߹ߴؿ (int ֤ΤϤ褯ʤ)
    // ֤ͤϥǡ: 1=¿᤮ 0=Ŭ -1=ʲ᤮
    friend int operator>>( istream&, StationData& );

  private:
    void error26_name() {
        cerr << "Error: subscript out of range (StationDataCell)\n";
    }

};

#endif /* ! ___STATIONDATA_HH */
