// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Prof. SONE's Laboratory, the Univ. of Tokyo.)
// TrainSchedCell.cc --- class TrainSchedCell functions
// $Id: TrainSchedCell.cc,v 4.0.1.1 1996/07/08 06:24:44 rt Exp $

#include "TrainSchedCell.hh"
#include "ReadData.hh"

RegexContainer rgc;

// TrainDelayCell 饹֥ȤΥեؤν
ostream& operator<<
( ostream& str, TrainSchedCell& x )
{
    str << "# [ȯ] [ȯ] [] [] "
        << "[] [] [ξ]\n";
    str << x.id_stn_dep << "  " << x.tm_dep << "  "
        << x.id_stn_arr << "  " << x.tm_arr << "  "
        << x.capacity << "  " << x.cap_seat << "  "
        << x.num_cars << "\n";
    return str;
}


// TrainSchedCell 饹֥ȤؤΥե뤫
int operator>>
( istream& str, TrainSchedCell& x )
{
  size_t nm;
  regmatch_t* pm;
  x.cyc_tr = 0;
  // ϩֹʳΥǡ
  if ( getint ( str, x.id_stn_dep ) == EOF ) return -1;
  if ( getinttime ( str, x.tm_dep ) == EOF ) return -1;
  if ( getint ( str, x.id_stn_arr ) == EOF ) return -1;
  if ( getinttime ( str, x.tm_arr ) == EOF ) return -1;
  if ( getint ( str, x.capacity ) == EOF ) return -1;
  if ( getint ( str, x.cap_seat ) == EOF ) return -1;
  if ( getint ( str, x.num_cars ) == EOF ) return -1;

    // ϩֹν
    x.lnc.renew();
    LineNumberContainerCell tmplncc;
    tmplncc.id_stn_st = x.id_stn_dep;
    string tmpuntil;
    while ( 1 ) {
        if ( getcommand ( str, tmpuntil ) == EOF ) return -1;
        if ( ! regexec( &(rgc._until), tmpuntil.c_str(), nm, pm, REG_NOTBOL ) ) {
            if ( getint ( str, tmplncc.id_stn_end ) == EOF ) return -1;
            if ( getint ( str, tmplncc.id_line ) == EOF ) return -1;
            x.lnc += tmplncc;
            tmplncc.id_stn_st = tmplncc.id_stn_end;
            continue;
        } else {
            if ( getintfromstring( tmpuntil, tmplncc.id_line ) == EOF )
                return -1;
            tmplncc.id_stn_end = x.id_stn_arr;
            x.lnc += tmplncc;
            break;
        }
    }

    cerr << setw(3) << setfill(' ') << x.id_stn_dep << setw(0) << "ȯ"
         << setw(5) << setfill(' ') << x.tm_dep << setw(0) << " ->"
         << setw(3) << setfill(' ') << x.id_stn_arr << setw(0) << ""
         << setw(5) << setfill(' ') << x.tm_arr << setw(0) << "("
         << setw(4) << setfill(' ') << x.capacity << setw(0) << "["
         << setw(4) << setfill(' ') << x.cap_seat << setw(0) << "], "
         << setw(2) << setfill(' ') << x.num_cars << setw(0) << "ξ), ϩ";
    for ( register int i = 0; i < x.lnc.number(); i++ )
        cerr << x.lnc[ i ].id_stn_st << "(" << x.lnc[ i ].id_line << ")";
    cerr << x.lnc.last().id_stn_end << "\n";
    return 0;	// Ǥ¿᤮ΥåϤʤ
}


ostream& operator<<
( ostream& str, TrainSchedCellEval& x )
{
    TrainSchedCell& xx = x;
    str << xx;
    str << x.capacity << "  # \n"
        << x.cap_seat << "  # \n"
        << x.num_cars << "  # ξ\n"
        << x.num_passen << "  # ¾Ϳ\n"
        << x.loss_stand << "  # Ω»\n";
    return str;
}


int operator>>
( istream& str, TrainSchedCellEval& x )
{
    TrainSchedCell& xx = x;
    if ( str >> xx ) return -1;
    if ( getint ( str, x.capacity ) == EOF ) return -1;
    if ( getint ( str, x.cap_seat ) == EOF ) return -1;
    if ( getint ( str, x.num_cars ) == EOF ) return -1;
    if ( getint ( str, x.num_passen ) == EOF ) return -1;
    if ( getdouble ( str, x.loss_stand ) == EOF ) return -1;
    return 0;	// Ǥ¿᤮ΥåϤʤ
}
